<?php

/**
 * Hooks
 *
 * @package     PG_Core
 *
 * @copyright   Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author      Pilot Group Ltd <http://www.pilotgroup.net/>
 */

if (!function_exists('set_profiling')) {
    $start_exec_time = 0;

    /**
     * Set database profiling timer
     *
     * @package     PG_Core
     * @subpackage  Hooks
     *
     * @category    hooks
     *
     * @copyright   Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
     * @author      Pilot Group Ltd <http://www.pilotgroup.net/>
     *
     * @return void
     */
    function set_profiling()
    {
        if ($_ENV['USE_PROFILING']) {
            global $start_exec_time;
            $start_exec_time = getmicrotime();
        }
    }
}
if (!function_exists('getmicrotime')) {
    /**
     * Get database profiling timer
     *
     * @package     PG_Core
     * @subpackage  Hooks
     *
     * @category    hooks
     *
     * @copyright   Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
     * @author      Pilot Group Ltd <http://www.pilotgroup.net/>
     *
     * @return float
     */
    function getmicrotime()
    {
        list($usec, $sec) = explode(" ", microtime());

        return ((float) $usec + (float) $sec);
    }
}
