<?php

/**
 * Aviary module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Aviary management
 *
 * @package 	PG_RealEstate
 * @subpackage 	Aviary
 *
 * @category	helpers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

if (!function_exists('aviary_editor_block')) {
    /**
     * Include aviary editor scripts
     *
     *
     * @return string
     */
    function aviary_editor_block()
    {
        $ci = &get_instance();

        $used = $ci->pg_module->get_module_config('aviary', 'used');
        $api_key = $ci->pg_module->get_module_config('aviary', 'api_key');

        if (!$used || !$api_key) {
            return '';
        }

        return $ci->view->fetch('helper_editor', null, 'aviary');
    }
}

if (!function_exists('aviary_editor_button')) {
    /**
     * Return aviary editor button
     *
     * @param array $params block parameters
     *
     * @return string
     */
    function aviary_editor_button($params)
    {
        $ci = &get_instance();

        if (empty($params['id']) || empty($params['source']) ||
           empty($params['module_gid']) || empty($params['save_callback'])) {
            return '';
        }

        $used = $ci->pg_module->get_module_config('aviary', 'used');
        $api_key = $ci->pg_module->get_module_config('aviary', 'api_key');

        if (!$used || !$api_key) {
            return '';
        }

        if (empty($params['post_url'])) {
            $params['post_url'] = '';
        }

        if (empty($params['post_data'])) {
            $params['post_data'] = array();
        }
        
        $ci->view->assign('aviary_api_key', $api_key);

        $ci->view->assign('aviary_module', $params['module_gid']);
        $ci->view->assign('aviary_photo_id', $params['id']);
        $ci->view->assign('aviary_photo_source', $params['source']);
        $ci->view->assign('aviary_post_url', $params['post_url']);
        $ci->view->assign('aviary_post_data', json_encode($params['post_data']));
        $ci->view->assign('aviary_save_callback', $params['save_callback']);

        $ci->load->model('Aviary_model');
        $aviary_code = $ci->Aviary_model->save_encode($params['module_gid'], $params['post_data']);
        $ci->view->assign('aviary_code', $aviary_code);

        $ci->view->assign('avaiary_button_rand', rand(100000, 999999));

        if (include(APPPATH . 'modules/aviary/install/languages' . EXT)) {
            $lang_code = $ci->pg_language->languages[$ci->pg_language->current_lang_id]['code'];
            if (isset($languages['aviary'][$lang_code])) {
                $ci->view->assign('aviary_lang_code', $languages['aviary'][$lang_code]);
            }
        }

        return $ci->view->fetch('helper_button', null, 'aviary');
    }
}
