<?php

namespace Pg\Modules\Content\Models;

/**
 * Content module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Content install model
 *
 * @package 	PG_RealEstate
 * @subpackage 	Content
 *
 * @category	models
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Content_install_model extends \Model
{

    /**
     * Link to CodeIgniter object
     *
     * @var object
     */
    protected $CI;

    /**
     * Menu configuration
     *
     * @var array
     */
    protected $menu = array(
        'admin_menu' => array(
            'action' => 'none',
            'name' => '',
            'items' => array(
                'settings_items' => array(
                    'action' => 'none',
                    'items' => array(
                        'content_items' => array(
                            'action' => 'none',
                            'items' => array(
                                'content_menu_item' => array('action' => 'create', 'link' => 'admin/content', 'status' => 1, 'sorter' => 3),
                            ),
                        ),
                        'interface-items' => array(
                            'action' => 'none',
                            'items' => array(
                                'promo_menu_item' => array('action' => 'create', 'link' => 'admin/content/promo', 'status' => 1, 'sorter' => 5),
                            ),
                        ),
                    ),
                ),
            ),
        ),
        'user_footer_menu' => array(
            'action' => 'none',
            'name' => '',
            'items' => array(
                'footer-menu-about-us-item' => array('action' => 'create', 'link' => 'content/view/about_us', 'status' => 1, 'sortet' => 1),
                'footer-menu-terms-item' => array('action' => 'create', 'link' => 'content/view/legal-terms', 'status' => 1, 'sortet' => 4),
            ),
        ),
        'private_main_menu' => array(
            'action' => 'none',
            'name' => '',
            'items' => array(
                'private-main-help-item' => array('action' => 'create', 'link' => 'content/view/help', 'status' => 1, 'sorter' => 11),
            ),
        ),
        'company_main_menu' => array(
            'action' => 'none',
            'name' => '',
            'items' => array(
                'company-main-help-item' => array('action' => 'create', 'link' => 'content/view/help', 'status' => 1, 'sorter' => 11),
            ),
        ),
        'agent_main_menu' => array(
            'action' => 'none',
            'name' => '',
            'items' => array(
                'agent-main-help-item' => array('action' => 'create', 'link' => 'content/view/help', 'status' => 1, 'sorter' => 11),
            ),
        ),
        'guest_main_menu' => array(
            'action' => 'none',
            'name' => '',
            'items' => array(
                'guest-main-help-item' => array('action' => 'create', 'link' => 'content/view/help', 'status' => 1, 'sorter' => 11),
            ),
        ),
        /*
        'private_slide_menu' => array(
            'action' => 'none',
            'name' => '',
            'items' => array(
                'private-slide-help-item' => array('action' => 'create', 'link' => 'content/view/help', 'status' => 1, 'sorter' => 11),
            ),
        ),
        'company_slide_menu' => array(
            'action' => 'none',
            'name' => '',
            'items' => array(
                'company-slide-help-item' => array('action' => 'create', 'link' => 'content/view/help', 'status' => 1, 'sorter' => 11),
            ),
        ),
        'agent_slide_menu' => array(
            'action' => 'none',
            'name' => '',
            'items' => array(
                'agent-slide-help-item' => array('action' => 'create', 'link' => 'content/view/help', 'status' => 1, 'sorter' => 11),
            ),
        ),
        'guest_slide_menu' => array(
            'action' => 'none',
            'name' => '',
            'items' => array(
                'guest-slide-help-item' => array('action' => 'create', 'link' => 'content/view/help', 'status' => 1, 'sorter' => 11),
            ),
        ),
         */
    );
    protected $banners_menu = array(
        'user_footer_menu' => array(
            'action' => 'none',
            'name' => '',
            'items' => array(
                'footer-menu-advertise-item' => array('action' => 'create', 'link' => 'content/view/advertising', 'status' => 1, 'sorter' => 3)
            )
        )
    );

    /**
     * Moderators configuration
     *
     * @var array
     */
    protected $moderators_methods = array(
        array('module' => 'content', 'method' => 'index', 'is_default' => 1),
        array('module' => 'content', 'method' => 'promo', 'is_default' => 0),
    );

    /**
     * Dynamic blocks configuration
     *
     * @var array
     */
    protected $dynamic_blocks = array(
        array(
            'gid' => 'content_promo_block',
            'module' => 'content',
            'model' => 'Content_promo_model',
            'method' => '_dynamic_block_get_content_promo',
            'params' => '',
            'views' => 'a:1:{i:0;s:7:"default";}',
            /*'area' => array(
                'gid' => 'index-page',
                'params' => 'a:0:{}',
                'view_str' => 'default',
                'width' => 100,
                'cache_time' => '600',
                'sorter' => 1,
            ),*/
            'presets' => array(
                array(
                    'gid_preset' => 'default',
                    'gid_area' => 'index-page',
                    'params' => array(),
                    'view_str' => 'default',
                    'width' => 100,
                    'cache_time' => '600',
                    'sorter' => 1,
                ),
                array(
                    'gid_preset' => 'agency',
                    'gid_area' => 'index-page',
                    'params' => array(),
                    'view_str' => 'default',
                    'width' => 100,
                    'cache_time' => '600',
                    'sorter' => 1,
                ),
                array(
                    'gid_preset' => 'agent',
                    'gid_area' => 'index-page',
                    'params' => array(),
                    'view_str' => 'default',
                    'width' => 100,
                    'cache_time' => '600',
                    'sorter' => 1,
                ),
            ),
        ),        
        array(
            'gid' => 'content_page_block',
            'module' => 'content',
            'model' => 'Content_model',
            'method' => '_dynamic_block_get_info_page',
            'params' => 'a:1:{s:16:"select_info_page";a:2:{s:4:"type";s:6:"select";s:7:"default";s:0:"";}}',
            'views' => 'a:1:{i:0;s:7:"default";}',
            'area' =>  array(
                'gid' => 'index-page',
                'params' => 'a:1:{s:16:"select_info_page";s:10:"mobile_app";}',
                'view_str' => 'default',
                'width' => 100,
                'cache_time' => '0',
                'sorter' => 20,
            ),
            'presets' => array(
                array(
                    'gid_preset' => 'default',
                    'gid_area' => 'index-page',
                    'params' => array('select_info_page' => 'mobile_app'),
                    'view_str' => 'default',
                    'width' => 100,
                    'cache_time' => '0',
                    'sorter' => 20,
                ),
            ),
        ),
    );

    /**
     * Uploads configuration
     *
     * @var array
     */
    protected $uploads = array(
        array(
            'gid' => 'promo-content-img',
            'name' => 'Promo content image',
            'max_height' => 2000,
            'max_width' => 1200,
            'max_size' => 1000000,
            'name_format' => 'generate',
            'file_formats' => array("jpg", "gif", "png"),
            'default_img' => '',
            'thumbs' => array(),
        ),
        array(
            "gid" => "promo-slider",
            "name" => "Promo slider",
            "min_height" => 400,
            "min_width" => 400,
            "max_height" => 5000,
            "max_width" => 5000,
            "max_size" => 10000000,
            "name_format" => "generate",
            "file_formats" => array("jpg", "gif", "png"),
            "default_img" => "",
            "thumbs" => array(
                "1600_440" => array("width" => 1600, "height" => 440, "effect" => "none", "watermark" => "", "crop_param" => "crop", "crop_color" => "ffffff"),
                "980_440" => array("width" => 980, "height" => 440, "effect" => "none", "watermark" => "", "crop_param" => "crop", "crop_color" => "ffffff"),
                "654_395" => array("width" => 654, "height" => 395, "effect" => "none", "watermark" => "", "crop_param" => "crop", "crop_color" => "ffffff"),
                "200_200" => array("width" => 200, "height" => 200, "effect" => "none", "watermark" => "", "crop_param" => "crop", "crop_color" => "ffffff"),
            ),
        ),
        array(
            'gid' => 'info-page-logo',
            'name' => 'Info page image',
            'min_height' => 200,
            'min_width' => 200,
            'max_height' => 1000,
            'max_width' => 1000,
            'max_size' => 1000000,
            'name_format' => 'generate',
            'file_formats' => array("jpg", "gif", "png"),
            'default_img' => '',
            'thumbs' => array(
                'big' => array('width' => 300, 'height' => 300, 'effect' => 'none', 'watermark' => '', 'crop_param' => 'crop', 'crop_color' => "ffffff"),
                'middle' => array('width' => 200, 'height' => 200, 'effect' => 'none', 'watermark' => '', 'crop_param' => 'crop', 'crop_color' => "ffffff"),
                'small' => array('width' => 100, 'height' => 100, 'effect' => 'none', 'watermark' => '', 'crop_param' => 'crop', 'crop_color' => "ffffff"),
            ),
        ),
    );

    /**
     * Upload gallery configuration
     *
     * @var array
     */
    protected $upload_gallery = array(
        array("gid" => "promo-slider", "name" => "Promo slider", "gid_upload_config" => "promo-slider", "max_items_count" => 15, "use_moderation" => 0, "module" => "content", "model" => "Content_promo_model", "callback" => "slider_callback", 'thumbs' => array('1600_440', '980_440', '654_395', '200_200')),
    );

    /**
     * File uploads configuration
     *
     * @var array
     */
    protected $file_uploads = array(
        array(
            "gid" => "promo-content-flash",
            "name" => "Promo content flash",
            "max_size" => 1000000,
            "name_format" => "generate",
            "file_formats" => array("swf"),
        ),
    );

    /**
     * Video uploads configuration
     *
     * @var array
     */
    protected $video_uploads = array(
        array(
            "gid" => "promo-video",
            "name" => "Promo video",
            "max_size" => 1073741824,
            "file_formats" => array("avi", "flv", "mkv", "asf", "mpeg", "mpg", "mov"),
            "default_img" => "",
            "upload_type" => "local",
            "use_convert" => 1,
            "use_thumbs" => 1,
            "module" => "content",
            "model" => "Content_promo_model",
            "method_status" => "video_callback",
            "thumbs_settings" => array(array("gid" => "small", "width" => 100, "height" => 70, "animated" => 0)),
            "local_settings" => array("width" => 980, "height" => 400, "audio_freq" => 22050, "audio_brate" => "64k", "video_brate" => "300k", "video_rate" => 100),
        ),
    );

    /**
     * Social networking configuration
     *
     * @var array
     */
    protected $social_networking = array(
        array(
            'controller' => 'content',
            'method' => 'view',
            'name' => 'View content page',
            'data' => array(
                'like' => array('facebook' => 'on', 'vkontakte' => 'on', 'google' => 'on'),
                'share' => array('facebook' => 'on', 'vkontakte' => 'on', 'linkedin' => 'on', 'twitter' => 'on'),
                'comments' => 1,
            ),
        ),
    );

    /**
     * Site map configuration
     *
     * @var array
     */
    protected $site_map_data = array(
        "module_gid" => "content",
        "model_name" => "Content_model",
        "get_urls_method" => "get_sitemap_urls",
    );

    /**
     * Fields depended on languages
     *
     * @var array
     */
    protected $lang_dm_data = array(
        array(
            "module" => "content",
            "model" => "Content_model",
            "method_add" => "lang_dedicate_module_callback_add",
            "method_delete" => "lang_dedicate_module_callback_delete",
        ),
        array(
            'module' => 'content',
            'model' => 'Content_promo_model',
            "method_add" => "lang_dedicate_module_callback_add",
            "method_delete" => "lang_dedicate_module_callback_delete",
        ),
    );

    /**
     * Class constructor
     *
     * @return Content_install_model
     */
    public function __construct()
    {
        parent::__construct();
        $this->CI = &get_instance();
        $this->CI->load->model('Install_model');
    }

    /**
     * Install data of menu module
     *
     * @return void
     */
    public function install_menu()
    {
        $this->CI->load->helper('menu');
        foreach ($this->menu as $gid => $menu_data) {
            $this->menu[$gid]['id'] = linked_install_set_menu($gid, $menu_data["action"], $menu_data["name"]);
            linked_install_process_menu_items($this->menu, 'create', $gid, 0, $this->menu[$gid]["items"]);
        }
    }

    /**
     * Import languages of menu module
     *
     * @param array $langs_ids languages identifiers
     *
     * @return void
     */
    public function install_menu_lang_update($langs_ids = null)
    {
        if (empty($langs_ids)) {
            return false;
        }
        $langs_file = $this->CI->Install_model->language_file_read('content', 'menu', $langs_ids);

        if (!$langs_file) {
            log_message('info', 'Empty menu langs data');

            return false;
        }

        $this->CI->load->helper('menu');

        foreach ($this->menu as $gid => $menu_data) {
            linked_install_process_menu_items($this->menu, 'update', $gid, 0, $this->menu[$gid]["items"], $gid, $langs_file);
        }

        return true;
    }

    /**
     * Export languages of menu module
     *
     * @param array $langs_ids languages identifiers
     *
     * @return array
     */
    public function install_menu_lang_export($langs_ids)
    {
        if (empty($langs_ids)) {
            return false;
        }
        $this->CI->load->helper('menu');

        $return = array();
        foreach ($this->menu as $gid => $menu_data) {
            $temp = linked_install_process_menu_items($this->menu, 'export', $gid, 0, $this->menu[$gid]["items"], $gid, $langs_ids);
            $return = array_merge($return, $temp);
        }

        return array("menu" => $return);
    }

    /**
     * Uninstall data of menu module
     *
     * @return void
     */
    public function deinstall_menu()
    {
        $this->CI->load->helper('menu');
        foreach ($this->menu as $gid => $menu_data) {
            if ($menu_data['action'] == 'create') {
                linked_install_set_menu($gid, 'delete');
            } else {
                linked_install_delete_menu_items($gid, $this->menu[$gid]['items']);
            }
        }
    }

    /**
     * Install data of uploads module
     *
     * @return void
     */
    public function install_uploads()
    {
        ///// upload config
        $this->CI->load->model("uploads/models/Uploads_config_model");

        $watermark_ids = array();

        foreach ((array) $this->uploads as $upload_data) {
            $config_data = array(
                "gid" => $upload_data["gid"],
                "name" => $upload_data["name"],
                "min_height" => isset($upload_data["min_height"]) ? $upload_data["min_height"] : 0,
                "min_width" => isset($upload_data["min_width"]) ? $upload_data["min_width"] : 0,
                "max_height" => $upload_data["max_height"],
                "max_width" => $upload_data["max_width"],
                "max_size" => $upload_data["max_size"],
                "name_format" => $upload_data["name_format"],
                "file_formats" => serialize((array) $upload_data["file_formats"]),
                "default_img" => $upload_data["default_img"],
                "date_add" => date("Y-m-d H:i:s"),
            );
            $config_id = $this->CI->Uploads_config_model->save_config(null, $config_data);

            $wm_data = $this->CI->Uploads_config_model->get_watermark_by_gid("image-wm");
            $wm_id = isset($wm_data["id"]) ? $wm_data["id"] : 0;

            foreach ((array) $upload_data["thumbs"] as $thumb_gid => $thumb_data) {
                if (isset($thumb_data["watermark"])) {
                    if (!isset($watermark_ids[$thumb_data["watermark"]])) {
                        $wm_data = $this->CI->Uploads_config_model->get_watermark_by_gid($thumb_data["watermark"]);
                        $watermark_ids[$thumb_data["watermark"]] = isset($wm_data["id"]) ? $wm_data["id"] : 0;
                    }
                    $watermark_id = $watermark_ids[$thumb_data["watermark"]];
                } else {
                    $watermark_id = 0;
                }

                $thumb_data["config_id"] = $config_id;
                $thumb_data["prefix"] = $thumb_gid;
                $thumb_data["effect"] = "none";
                $thumb_data["watermark_id"] = $watermark_id;

                $validate_data = $this->CI->Uploads_config_model->validate_thumb(null, $thumb_data);
                if (!empty($validate_data["errors"])) {
                    continue;
                }
                $this->CI->Uploads_config_model->save_thumb(null, $validate_data["data"]);
            }
        }
    }

    /**
     * Uninstall data of uploads module
     *
     * @return void
     */
    public function deinstall_uploads()
    {
        $this->CI->load->model("uploads/models/Uploads_config_model");

        foreach ((array) $this->uploads as $upload_data) {
            $config_data = $this->CI->Uploads_config_model->get_config_by_gid($upload_data["gid"]);
            if (!empty($config_data["id"])) {
                $this->CI->Uploads_config_model->delete_config($config_data["id"]);
            }
        }
    }

    /**
     * Install data of upload gallery module
     *
     * @return void
     */
    public function install_upload_gallery()
    {
        $this->CI->load->model("Upload_gallery_model");

        foreach ((array) $this->upload_gallery as $gallery_data) {
            $validate_data = $this->CI->Upload_gallery_model->validate_type(null, $gallery_data);
            if (!empty($validate_data["errors"])) {
                continue;
            }
            $this->CI->Upload_gallery_model->set_type(null, $validate_data["data"]);
        }
    }

    /**
     * Import languages of upload gallery module
     *
     * @param array $langs_ids languages identifiers
     *
     * @return boolean
     */
    public function install_upload_gallery_lang_update($langs_ids = null)
    {
        if (empty($langs_ids)) {
            return false;
        }

        $this->CI->load->model("Upload_gallery_model");

        $langs_file = $this->CI->Install_model->language_file_read("content", "upload_gallery", $langs_ids);
        if (!$langs_file) {
            log_message("info", "Empty upload_gallery langs data");

            return false;
        }

        $this->CI->Upload_gallery_model->update_langs($this->upload_gallery, $langs_file, $langs_ids);

        return true;
    }

    /**
     * Export languages of upload gallery module
     *
     * @param array $langs_ids languages identifiers
     *
     * @return array
     */
    public function install_upload_gallery_lang_export($langs_ids = null)
    {
        $this->CI->load->model("Upload_gallery_model");
        $langs = $this->CI->Upload_gallery_model->export_langs((array) $this->upload_gallery, $langs_ids);

        return array("upload_gallery" => $langs);
    }

    /**
     * Uninstall data of upload gallery module
     *
     * @return void
     */
    public function deinstall_upload_gallery()
    {
        $this->CI->load->model("Upload_gallery_model");
        foreach ((array) $this->upload_gallery as $gallery_data) {
            $type = $this->CI->Upload_gallery_model->get_type_by_gid($gallery_data["gid"]);
            if (!$type) {
                continue;
            }
            $this->CI->Upload_gallery_model->delete_type($type["id"]);
        }
    }

    /**
     * Install data of file uploads module
     *
     * @return void
     */
    public function install_file_uploads()
    {
        // add file settings
        $this->CI->load->model("file_uploads/models/File_uploads_config_model");
        foreach ((array) $this->file_uploads as $config_data) {
            $validate_data = $this->CI->File_uploads_config_model->validate_config(null, $config_data);
            if (!empty($validate_data["errors"])) {
                continue;
            }
            $this->CI->File_uploads_config_model->save_config(null, $validate_data["data"]);
        }
    }

    /**
     * Uninstall data of file uploads module
     *
     * @return void
     */
    public function deinstall_file_uploads()
    {
        // delete file settings
        $this->CI->load->model('file_uploads/models/File_uploads_config_model');
        foreach ((array) $this->file_uploads as $config_data) {
            $config_data = $this->CI->File_uploads_config_model->get_config_by_gid($config_data["gid"]);
            if (empty($config_data["id"])) {
                continue;
            }
            $this->CI->File_uploads_config_model->delete_config($config_data["id"]);
        }
    }

    /**
     * Install data of video uploads module
     *
     * @return void
     */
    public function install_video_uploads()
    {
        $this->CI->load->model("video_uploads/models/Video_uploads_config_model");
        foreach ((array) $this->video_uploads as $config_data) {
            $validate_data = $this->CI->Video_uploads_config_model->validate_config(null, $config_data);
            if (!empty($validate_data["errors"])) {
                continue;
            }
            $validate_data["data"]["gid"] = $config_data["gid"];
            $validate_data["data"]["module"] = $config_data["module"];
            $validate_data["data"]["model"] = $config_data["model"];
            $validate_data["data"]["method_status"] = $config_data["method_status"];
            $this->CI->Video_uploads_config_model->save_config(null, $validate_data["data"]);
        }
    }

    /**
     * Uninstall data of video uploads module
     *
     * @return void
     */
    public function deinstall_video_uploads()
    {
        ///// delete video settings
        $this->CI->load->model("video_uploads/models/Video_uploads_config_model");
        foreach ((array) $this->video_uploads as $config_data) {
            $config_data = $this->CI->Video_uploads_config_model->get_config_by_gid($config_data["gid"]);
            if (empty($config_data["id"])) {
                continue;
            }
            $this->CI->Video_uploads_config_model->delete_config($config_data["id"]);
        }
    }

    /**
     * Install data of dynamic blocks module
     *
     * @return void
     */
    public function install_dynamic_blocks()
    {
        $this->CI->load->model('Dynamic_blocks_model');

        foreach ($this->dynamic_blocks as $block) {
            $block_data = array(
                'gid' => $block['gid'],
                'module' => $block['module'],
                'model' => $block['model'],
                'method' => $block['method'],
                'params' => $block['params'],
                'views' => $block['views'],
            );
            $id_block = $this->CI->Dynamic_blocks_model->save_block(null, $block_data);
            if (!empty($block['area'])) {
                $area_index = $this->CI->Dynamic_blocks_model->get_area_by_gid($block['area']['gid']);
                $area_data = array(
                    'id_area' => $area_index['id'],
                    'id_block' => $id_block,
                    'params' => $block['area']['params'],
                    'width' => $block['area']['width'],
                    'view_str' => $block['area']['view_str'],
                    'cache_time' => $block['area']['cache_time'],
                    'sorter' => $block['area']['sorter'],
                );
                $temp_id = $this->CI->Dynamic_blocks_model->save_area_block(null, $area_data);
                $this->CI->Dynamic_blocks_model->save_area_block_sorter($temp_id, $block['area']['sorter']);
            }
            if (!empty($block["presets"])) {
                foreach ($block["presets"] as $preset_data) {
                    $preset = $this->CI->Dynamic_blocks_model->get_preset_by_gid($preset_data['gid_preset']);
                    $preset_data['id_preset'] = $preset['id'];
                    $preset_data['id_block'] = $id_block;
                    $validate_data = $this->CI->Dynamic_blocks_model->validate_preset_block(null, $preset_data);
                    if (!empty($validate_data["errors"])) {
                        continue;
                    }
                    $this->CI->Dynamic_blocks_model->save_preset_block(null, $validate_data["data"]);
                }
            }
        }
    }

    /**
     * Import language of dynamic blocks module
     *
     * @param array $langs_ids languages identifiers
     *
     * @return void
     */
    public function install_dynamic_blocks_lang_update($langs_ids = null)
    {
        if (empty($langs_ids)) {
            return false;
        }
        $langs_file = $this->CI->Install_model->language_file_read('content', 'dynamic_blocks', $langs_ids);
        if (!$langs_file) {
            log_message('info', 'Empty dynamic_blocks langs data');

            return false;
        }
        $this->CI->load->model('Dynamic_blocks_model');
        $data = array();

        foreach ((array) $this->dynamic_blocks as $block_data) {
            $block = $this->CI->Dynamic_blocks_model->get_block_by_gid($block_data["gid"]);
            if (!$block) {
                continue;
            }
            $data[] = $block;
        }

        $this->CI->Dynamic_blocks_model->update_langs($data, $langs_file, $langs_ids);
    }

    /**
     * Export language of dynamic blocks module
     *
     * @param array $langs_ids languages identifiers
     *
     * @return array
     */
    public function install_dynamic_blocks_lang_export($langs_ids = null)
    {
        if (!is_array($langs_ids)) {
            $langs_ids = (array) $langs_ids;
        }
        $this->CI->load->model("Dynamic_blocks_model");
        $data = array();

        foreach ((array) $this->dynamic_blocks as $block_data) {
            $block = $this->CI->Dynamic_blocks_model->get_block_by_gid($block_data["gid"]);
            if (!$block) {
                continue;
            }
            $data[] = $block;
        }

        $langs = $this->CI->Dynamic_blocks_model->export_langs($data, $langs_ids);

        return array("dynamic_blocks" => $langs);
    }

    /**
     * Uninstall data of dynamic blocks module
     *
     * @return void
     */
    public function deinstall_dynamic_blocks()
    {
        $this->CI->load->model('Dynamic_blocks_model');
        foreach ($this->dynamic_blocks as $block) {
            $this->CI->Dynamic_blocks_model->delete_block_by_gid($block['gid']);
        }
    }

    /**
     * Install data of banners module
     *
     * @return void
     */
    public function install_banners()
    {
        // add banners module
        $this->CI->load->model('Content_model');
        $this->CI->load->model('banners/models/Banner_group_model');
        $this->CI->load->model('banners/models/Banner_place_model');
        $this->CI->Banner_group_model->set_module("content", "Content_model", "_banner_available_pages");

        $group_id = $this->CI->Banner_group_model->get_group_id_by_gid('content_groups');
        ///add pages in group
        $pages = $this->CI->Content_model->_banner_available_pages();
        if ($pages) {
            foreach ($pages as $key => $value) {
                $page_attrs = array(
                    'group_id' => $group_id,
                    'name' => $value['name'],
                    'link' => $value['link'],
                );
                $this->CI->Banner_group_model->add_page($page_attrs);
            }
        }

        $this->CI->load->helper('menu');

        foreach ($this->banners_menu as $gid => $menu_data) {
            $this->banners_menu[$gid]['id'] = linked_install_set_menu($gid, $menu_data["action"], $menu_data["name"]);
            linked_install_process_menu_items($add_menu, 'create', $gid, 0, $this->banners_menu[$gid]["items"]);
        }
    }

    /**
     * Import languages of menu module
     *
     * @param array $langs_ids languages identifiers
     *
     * @return void
     */
    public function install_banners_lang_update($langs_ids = null)
    {
        if (empty($langs_ids)) {
            return false;
        }
        $langs_file = $this->CI->Install_model->language_file_read('content', 'menu', $langs_ids);

        if (!$langs_file) {
            log_message('info', 'Empty menu langs data');

            return false;
        }

        $this->CI->load->helper('menu');

        foreach ($this->banners_menu as $gid => $menu_data) {
            linked_install_process_menu_items($this->banners_menu, 'update', $gid, 0, $this->banners_menu[$gid]["items"], $gid, $langs_file);
        }

        return true;
    }

    /**
     * Uninstall data of banners module
     *
     * @return void
     */
    public function deinstall_banners()
    {
        ///// delete banners module
        $this->CI->load->model("banners/models/Banner_group_model");
        $this->CI->Banner_group_model->delete_module("content");

        $this->CI->load->helper('menu');
        foreach ($this->banners_menu as $gid => $menu_data) {
            if ($menu_data['action'] == 'create') {
                linked_install_set_menu($gid, 'delete');
            } else {
                linked_install_delete_menu_items($gid, $this->banners_menu[$gid]['items']);
            }
        }
    }

    /**
     * Install data of moderators module
     *
     * @return void
     */
    public function install_moderators()
    {
        // install moderators permissions
        $this->CI->load->model('Moderators_model');

        foreach ($this->moderators_methods as $method) {
            $this->CI->Moderators_model->save_method(null, $method);
        }
    }

    /**
     * Import languages of moderators module
     *
     * @param array $langs_ids languages identifiers
     *
     * @return void
     */
    public function install_moderators_lang_update($langs_ids = null)
    {
        $langs_file = $this->CI->Install_model->language_file_read('content', 'moderators', $langs_ids);

        // install moderators permissions
        $this->CI->load->model('Moderators_model');
        $params['where']['module'] = 'content';
        $methods = $this->CI->Moderators_model->get_methods_lang_export($params);

        foreach ($methods as $method) {
            if (!empty($langs_file[$method['method']])) {
                $this->CI->Moderators_model->save_method($method['id'], array(), $langs_file[$method['method']]);
            }
        }
    }

    /**
     * Export languages of moderators module
     *
     * @param array $langs_ids languages identifiers
     *
     * @return array
     */
    public function install_moderators_lang_export($langs_ids)
    {
        $this->CI->load->model('Moderators_model');
        $params['where']['module'] = 'content';
        $methods = $this->CI->Moderators_model->get_methods_lang_export($params, $langs_ids);
        foreach ($methods as $method) {
            $return[$method['method']] = $method['langs'];
        }

        return array('moderators' => $return);
    }

    /**
     * Uninstall data of moderators module
     *
     * @return void
     */
    public function deinstall_moderators()
    {
        // delete moderation methods in moderators
        $this->CI->load->model('Moderators_model');
        $params['where']['module'] = 'contents';
        $this->CI->Moderators_model->delete_methods($params);
    }

    /**
     * Install data of social networking module
     *
     * @return void
     */
    public function install_social_networking()
    {
        ///// add social netorking page
        $this->CI->load->model('social_networking/models/Social_networking_pages_model');
        foreach ((array) $this->social_networking as $social_networking_data) {
            $validation_data = $this->CI->Social_networking_pages_model->validate_page(null, $social_networking_data);
            if (!empty($validation_data['errors'])) {
                continue;
            }
            $this->CI->Social_networking_pages_model->save_page(null, $validation_data['data']);
        }
    }

    /**
     * Uninstall data of social networking module
     *
     * @return void
     */
    public function deinstall_social_networking()
    {
        ///// delete social netorking page
        $this->CI->load->model('social_networking/models/Social_networking_pages_model');
        $this->CI->Social_networking_pages_model->delete_pages_by_controller('content');
    }

    /**
     * Install data of site map module
     *
     * @return void
     */
    public function install_site_map()
    {
        ////// site_map
        $this->CI->load->model("Site_map_model");
        $this->CI->Site_map_model->set_sitemap_module("content", $this->site_map_data);
    }

    /**
     * Uninstall data of site map module
     *
     * @return void
     */
    public function deinstall_site_map()
    {
        $this->CI->load->model("Site_map_model");
        $this->CI->Site_map_model->delete_sitemap_module("content");
    }

    /**
     * Install fields of dedicated languages
     *
     * @return void
     */
    public function _prepare_installing()
    {
        $this->CI->load->model("Content_model");
        foreach ($this->CI->pg_language->languages as $lang_id => $value) {
            $this->CI->Content_model->lang_dedicate_module_callback_add($lang_id);
        }

        $this->CI->load->model("content/models/Content_promo_model");
        foreach ($this->CI->pg_language->languages as $lang_id => $value) {
            $this->CI->Content_promo_model->lang_dedicate_module_callback_add($lang_id);
        }
    }

    /**
     * Install module data
     *
     * @return void
     */
    public function _arbitrary_installing()
    {
        // add entries for lang data updates
        foreach ($this->lang_dm_data as $lang_dm_data) {
            $this->CI->pg_language->add_dedicate_modules_entry($lang_dm_data);
        }

        ///// seo
        $seo_data = array(
            'module_gid' => 'content',
            'model_name' => 'Content_model',
            'get_settings_method' => 'get_seo_settings',
            'get_rewrite_vars_method' => 'request_seo_rewrite',
            'get_sitemap_urls_method' => 'get_sitemap_xml_urls',
        );
        $this->CI->pg_seo->set_seo_module('content', $seo_data);

        // add seo link
        $this->CI->load->model('Seo_model');

        $xml_data = $this->CI->Seo_model->get_xml_route_file_content();

        $data = array(
            'noindex' => 1,
            'title' => '',
            'keyword' => '',
            'description' => '',
            'header' => '',
            'og_title' => '',
            'og_type' => '',
            'og_descrtiption' => '',
            'url_template' => '[text:articles]',
        );
        $this->CI->pg_seo->set_settings('user', 'content', 'index', $data);

        $xml_data['content']['index'] = $this->CI->pg_seo->url_template_transform('content', 'index', $data["url_template"], 'base', 'xml');

        $data = array(
            'noindex' => 0,
            'title' => '',
            'keyword' => '',
            'description' => '',
            'header' => '',
            'og_title' => '',
            'og_type' => '',
            'og_descrtiption' => '',
            'url_template' => '[text:articles/][tpl:1:gid:literal:empty]',
        );
        $this->CI->pg_seo->set_settings('user', 'content', 'view', $data);

        $xml_data['content']['view'] = $this->CI->pg_seo->url_template_transform('content', 'view', $data["url_template"], 'base', 'xml');

        $this->CI->Seo_model->set_xml_route_file_content($xml_data);
        $this->CI->Seo_model->rewrite_route_php_file();

        $this->add_demo_content();
    }

    /**
     * Import module languages
     *
     * @param array $langs_ids languages identifiers
     *
     * @return void
     */
    public function _arbitrary_lang_install($langs_ids = null)
    {
        if (!is_array($langs_ids)) {
            $langs_ids = (array) $langs_ids;
        }
        $langs_file = $this->CI->Install_model->language_file_read('content', 'demo', $langs_ids);

        if (!$langs_file) {
            log_message('info', 'Empty arbitrary langs data');

            return false;
        }

        $this->CI->load->model("content/models/Content_promo_model");
        foreach ($langs_ids as $lang_id) {
            $promo["promo_text"] = $langs_file["content"][$lang_id];
            $this->CI->Content_promo_model->save_promo($lang_id, $promo);
        }

        $langs_file = $this->CI->Install_model->language_file_read("content", "arbitrary", $langs_ids);
        if (!$langs_file) {
            log_message("info", "Empty content arbitrary langs data");

            return false;
        }

        $post_data = array(
            "title" => $langs_file["seo_tags_index_title"],
            "keyword" => $langs_file["seo_tags_index_keyword"],
            "description" => $langs_file["seo_tags_index_description"],
            "header" => $langs_file["seo_tags_index_header"],
            "og_title" => $langs_file["seo_tags_index_og_title"],
            "og_type" => $langs_file["seo_tags_index_og_type"],
            "og_description" => $langs_file["seo_tags_index_og_description"],
        );
        $this->CI->pg_seo->set_settings("user", "content", "index", $post_data);

        $post_data = array(
            "title" => $langs_file["seo_tags_view_title"],
            "keyword" => $langs_file["seo_tags_view_keyword"],
            "description" => $langs_file["seo_tags_view_description"],
            "header" => $langs_file["seo_tags_view_header"],
            "og_title" => $langs_file["seo_tags_view_og_title"],
            "og_type" => $langs_file["seo_tags_view_og_type"],
            "og_description" => $langs_file["seo_tags_view_og_description"],
        );
        $this->CI->pg_seo->set_settings("user", "content", "view", $post_data);

        return;
    }

    /**
     * Export module languages
     *
     * @param array $langs_ids languages identifiers
     *
     * @return array
     */
    public function _arbitrary_lang_export($langs_ids = null)
    {
        if (!is_array($langs_ids)) {
            $langs_ids = (array) $langs_ids;
        }
        $this->CI->load->model("content/models/Content_promo_model");

        foreach ($langs_ids as $lang_id) {
            $promo = $this->CI->Content_promo_model->get_promo($lang_id);
            $langs["content"][$lang_id] = $promo["promo_text"];
        }

        //// arbitrary
        $settings = $this->CI->pg_seo->get_settings("user", "content", "index", $langs_ids);
        $arbitrary_return["seo_tags_index_title"] = $settings["title"];
        $arbitrary_return["seo_tags_index_keyword"] = $settings["keyword"];
        $arbitrary_return["seo_tags_index_description"] = $settings["description"];
        $arbitrary_return["seo_tags_index_header"] = $settings["header"];
        $arbitrary_return["seo_tags_index_og_title"] = $settings["og_title"];
        $arbitrary_return["seo_tags_index_og_type"] = $settings["og_type"];
        $arbitrary_return["seo_tags_index_og_description"] = $settings["og_description"];

        $settings = $this->CI->pg_seo->get_settings("user", "content", "view", $langs_ids);
        $arbitrary_return["seo_tags_view_title"] = $settings["title"];
        $arbitrary_return["seo_tags_view_keyword"] = $settings["keyword"];
        $arbitrary_return["seo_tags_view_description"] = $settings["description"];
        $arbitrary_return["seo_tags_view_header"] = $settings["header"];
        $arbitrary_return["seo_tags_view_og_title"] = $settings["og_title"];
        $arbitrary_return["seo_tags_view_og_type"] = $settings["og_type"];
        $arbitrary_return["seo_tags_view_og_description"] = $settings["og_description"];

        return array('demo' => $langs, "arbitrary" => $arbitrary_return);
    }

    /**
     * Uninstall module data
     *
     * @return void
     */
    public function _arbitrary_deinstalling()
    {
        // remove seo link
        $this->CI->load->model('Seo_model');

        $xml_data = $this->CI->Seo_model->get_xml_route_file_content();

        $data = array(
            'noindex' => 0,
            'title' => '',
            'keyword' => '',
            'description' => '',
            'header' => '',
            'og_title' => '',
            'og_type' => '',
            'og_descrtiption' => '',
            'url_template' => '',
        );
        $this->CI->pg_seo->set_settings('user', 'content', 'index', $data);

        $xml_data['content']['index'] = $this->CI->pg_seo->url_template_transform('content', 'index', $data["url_template"], 'base', 'xml');

        $data = array(
            'noindex' => 0,
            'title' => '',
            'keyword' => '',
            'description' => '',
            'header' => '',
            'og_title' => '',
            'og_type' => '',
            'og_descrtiption' => '',
            'url_template' => '',
        );
        $this->CI->pg_seo->set_settings('user', 'content', 'view', $data);

        $xml_data['content']['view'] = $this->CI->pg_seo->url_template_transform('content', 'view', $data["url_template"], 'base', 'xml');

        $this->CI->Seo_model->set_xml_route_file_content($xml_data);
        $this->CI->Seo_model->rewrite_route_php_file();

        $this->CI->pg_seo->delete_seo_module('content');

        /// delete entries in dedicate modules
        foreach ($this->lang_dm_data as $lang_dm_data) {
            $this->CI->pg_language->delete_dedicate_modules_entry(array('where' => $lang_dm_data));
        }
    }

    /**
     * Install demo content
     *
     * @return void
     */
    public function add_demo_content()
    {
        $this->CI->load->model('Content_model');
        $this->CI->load->model('content/models/Content_promo_model');

        include MODULEPATH . 'content/install/demo_content.php';

        $this->CI->Content_model->installPages($demo_content['pages']);

        if ($this->CI->pg_module->is_module_active("upload_gallery")) {
            $this->CI->load->model("Upload_gallery_model");

            $slider_type = $this->CI->Content_promo_model->get_slider_type();

            foreach ((array) $demo_content['uploads'] as $upload) {
                $upload["type_id"] = $slider_type["id"];

                if (isset($upload["id"])) {
                    if ($this->CI->Upload_gallery_model->get_file_by_id($upload["id"])) {
                        continue;
                    }
                }

                $validate_data = $this->CI->Upload_gallery_model->validate_file_data(null, $slider_type['id'], $upload);
                if (!empty($validate_data['errors'])) {
                    continue;
                }
                $validate_data['data'] = array_merge($upload, $validate_data['data']);

                $ret = $this->CI->Upload_gallery_model->save_file_data(null, $validate_data['data'], "", false);
            }
        }
    }

}
