<?php

namespace Pg\Modules\Dynamic_blocks\Models;

/**
 * Dynamic blocks module
 *
 * @package     PG_RealEstate
 *
 * @copyright   Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author      Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Dynamic blocks install model
 *
 * @package     PG_RealEstate
 * @subpackage  Dynamic blocks
 *
 * @category    models
 *
 * @copyright   Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author      Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Dynamic_blocks_install_model extends \Model
{

    /**
     * Link to CodeIgniter object
     *
     * @var object
     */
    protected $ci;

    /**
     * Menu configuration
     *
     * @var array
     */
    protected $menu = array(
        'admin_menu' => array(
            'action' => 'none',
            'name' => '',
            'items' => array(
                'settings_items' => array(
                    'action' => 'none',
                    'items' => array(
                        'interface-items' => array(
                            'action' => 'none',
                            'items' => array(
                                'dynblock_menu_item' => array('action' => 'create', 'link' => 'admin/dynamic_blocks', 'status' => 1, 'sorter' => 1),
                            ),
                        ),
                    ),
                ),
            ),
        ),
        'admin_dynblocks_menu' => array(
            'action' => 'create',
            'name' => 'Admin mode - Interface - Dynamic blocks',
            'items' => array(
                'areas_list_item' => array('action' => 'create', 'link' => 'admin/dynamic_blocks', 'status' => 1),
                'blocks_list_item' => array('action' => 'create', 'link' => 'admin/dynamic_blocks/blocks', 'status' => 0),
            ),
        ),
    );

    /**
     * Moderators configuration
     *
     * @var array
     */
    protected $moderators_methods = array(
        array('module' => 'dynamic_blocks', 'method' => 'index', 'is_default' => 1),
        array('module' => 'dynamic_blocks', 'method' => 'area_blocks', 'is_default' => 0),
    );

    /**
     * Dynamic blocks configuration
     *
     * @var array
     */
    protected $dynamic_blocks = array(
        array(
            "gid" => "html_code_block",
            "module" => "dynamic_blocks",
            "model" => "Dynamic_blocks_model",
            "method" => "_dynamic_block_get_html_code",
            "params" => array(
                "title" => array("gid" => "title", "type" => "text", "default" => ""),
                "html" => array("gid" => "html", "type" => "textarea", "default" => ""),
            ),
            "views" => array(array("gid" => "default")),
            "area" => array(
                "gid" => "index-page",
                "params" => array(
                    "html" => "<div id=\"fb-root\"></div>\n<script>(function(d, s, id) {\n  var js, fjs = d.getElementsByTagName(s)[0];\n  if (d.getElementById(id)) return;\n  js = d.createElement(s); js.id = id;\n  js.src = \"//connect.facebook.net/en_EN/sdk.js#xfbml=1&appId=105548532926787&version=v2.0\";\n  fjs.parentNode.insertBefore(js, fjs);\n}(document, 'script', 'facebook-jssdk'));</script>\n<div class=\"fb-like-box\" data-href=\"https://facebook.com/pilotgroup.net\" data-width=\"470\" data-colorscheme=\"light\" data-show-faces=\"true\" data-header=\"true\" data-stream=\"false\" data-show-border=\"true\"></div>",
                ),
                "view_str" => "default",
                'width' => 50,
                "cache_time" => "600",
                "sorter" => 5,
            ),
            "presets" => array(
                array(
                    "gid_preset" => "default",
                    "gid_area" => "index-page",
                    "params" => array(
                        "html" => "<div id=\"fb-root\"></div>\n<script>(function(d, s, id) {\n  var js, fjs = d.getElementsByTagName(s)[0];\n  if (d.getElementById(id)) return;\n  js = d.createElement(s); js.id = id;\n  js.src = \"//connect.facebook.net/en_EN/sdk.js#xfbml=1&appId=105548532926787&version=v2.0\";\n  fjs.parentNode.insertBefore(js, fjs);\n}(document, 'script', 'facebook-jssdk'));</script>\n<div class=\"fb-like-box\" data-href=\"https://facebook.com/pilotgroup.net\" data-width=\"470\" data-colorscheme=\"light\" data-show-faces=\"true\" data-header=\"true\" data-stream=\"false\" data-show-border=\"true\"></div>",
                    ),
                    "view_str" => "default",
                    'width' => 50,
                    "cache_time" => "600",
                    "sorter" => 5,
                ),
                array(
                    "gid_preset" => "classic",
                    "gid_area" => "index-page",
                    "params" => array(
                        'html' => "<div id=\"fb-root\"></div>\n<script>(function(d, s, id) {\n  var js, fjs = d.getElementsByTagName(s)[0];\n  if (d.getElementById(id)) return;\n  js = d.createElement(s); js.id = id;\n  js.src = \"//connect.facebook.net/ru_RU/sdk.js#xfbml=1&appId=105548532926787&version=v2.0\";\n  fjs.parentNode.insertBefore(js, fjs);\n}(document, 'script', 'facebook-jssdk'));</script>\n<div class=\"fb-like-box\" data-href=\"https://facebook.com/pilotgroup.net\" data-width=\"470\" data-colorscheme=\"light\" data-show-faces=\"true\" data-header=\"true\" data-stream=\"false\" data-show-border=\"true\"></div>",
                    ),
                    "view_str" => "default",
                    "width" => 50,
                    "cache_time" => "600",
                    "sorter" => 5,
                ),
                array(
                    "gid_preset" => "agency",
                    "gid_area" => "index-page",
                    "params" => array(
                        "html" => "<div id=\"fb-root\"></div>\n<script>(function(d, s, id) {\n  var js, fjs = d.getElementsByTagName(s)[0];\n  if (d.getElementById(id)) return;\n  js = d.createElement(s); js.id = id;\n  js.src = \"//connect.facebook.net/ru_RU/sdk.js#xfbml=1&appId=105548532926787&version=v2.0\";\n  fjs.parentNode.insertBefore(js, fjs);\n}(document, 'script', 'facebook-jssdk'));</script>\n<div class=\"fb-like-box\" data-href=\"https://facebook.com/pilotgroup.net\" data-width=\"470\" data-colorscheme=\"light\" data-show-faces=\"true\" data-header=\"true\" data-stream=\"false\" data-show-border=\"true\"></div>",
                    ),
                    "view_str" => "default",
                    'width' => 50,
                    "cache_time" => "600",
                    "sorter" => 7,
                ),
            ),
        ),
    );

    /**
     * Uploads configuration
     *
     * @var array
     */
    protected $uploads = array(
        array(
            "gid" => "preset-logo",
            "name" => "Presets logo",
            "min_height" => 200,
            "min_width" => 200,
            "max_height" => 1000,
            "max_width" => 1000,
            "max_size" => 200000,
            "name_format" => "generate",
            "file_formats" => array("jpg", "gif", "png"),
            "default_img" => "default_preset_logo.png",
            "thumbs" => array(),
        /* "thumbs" => array(
          "200_200" => array("width"=>200, "height"=>200, "effect"=>"none", "crop_param"=>"crop", "crop_color"=>"ffffff"),
          ), */
        ),
    );

    /**
     * Themes events
     *
     * @var array
     */
    protected $themes_events = array(
        'module' => 'dynamic_blocks',
        'model' => 'Dynamic_blocks_model',
        'activate_callback' => 'cache_all_clear',
    );

    /**
     * Fields depended on languages
     *
     * @var array
     */
    protected $lang_dm_data = array(
        array(
            "module" => "dynamic_blocks",
            "model" => "Dynamic_blocks_model",
            "method_add" => "lang_dedicate_module_callback_add",
            "method_delete" => "lang_dedicate_module_callback_delete",
        ),
    );

    /**
     * Constructor
     *
     * @return Dynamic_blocks_install_model
     */
    public function __construct()
    {
        parent::__construct();
        $this->ci = &get_instance();
        // load langs
        $this->ci->load->model('Install_model');
    }

    /**
     * Install data of menu module
     */
    public function install_menu()
    {
        $this->ci->load->helper('menu');
        foreach ($this->menu as $gid => $menu_data) {
            $this->menu[$gid]['id'] = linked_install_set_menu($gid, $menu_data["action"], $menu_data["name"]);
            linked_install_process_menu_items($this->menu, 'create', $gid, 0, $this->menu[$gid]["items"]);
        }
    }

    /**
     * Import languages of menu module
     *
     * @param array $langs_ids languages identifiers
     *
     * @return void
     */
    public function install_menu_lang_update($langs_ids = null)
    {
        if (empty($langs_ids)) {
            return false;
        }
        $langs_file = $this->ci->Install_model->language_file_read('dynamic_blocks', 'menu', $langs_ids);

        if (!$langs_file) {
            log_message('error', 'Empty menu langs data');
            return false;
        }

        $this->ci->load->helper('menu');

        foreach ($this->menu as $gid => $menu_data) {
            linked_install_process_menu_items($this->menu, 'update', $gid, 0, $this->menu[$gid]["items"], $gid, $langs_file);
        }

        return true;
    }

    /**
     * Export languages of menu module
     *
     * @param array $langs_ids languages identifiers
     *
     * @return array
     */
    public function install_menu_lang_export($langs_ids)
    {
        if (empty($langs_ids)) {
            return false;
        }
        $this->ci->load->helper('menu');

        $return = array();
        foreach ($this->menu as $gid => $menu_data) {
            $temp = linked_install_process_menu_items($this->menu, 'export', $gid, 0, $this->menu[$gid]["items"], $gid, $langs_ids);
            $return = array_merge($return, $temp);
        }

        return array("menu" => $return);
    }

    /**
     * Uninstall data of menu module
     *
     * @return void
     */
    public function deinstall_menu()
    {
        $this->ci->load->helper('menu');
        foreach ($this->menu as $gid => $menu_data) {
            if ($menu_data['action'] == 'create') {
                linked_install_set_menu($gid, 'delete');
            } else {
                linked_install_delete_menu_items($gid, $this->menu[$gid]['items']);
            }
        }
    }

    /**
     * Install data of moderators module
     *
     * @return void
     */
    public function install_moderators()
    {
        // install moderators permissions
        $this->ci->load->model('Moderators_model');

        foreach ($this->moderators_methods as $method) {
            $this->ci->Moderators_model->save_method(null, $method);
        }
    }

    /**
     * Import languages of asuers module
     *
     * @param array $langs_ids languages identifiers
     *
     * @return array
     */
    public function install_moderators_lang_update($langs_ids = null)
    {
        $langs_file = $this->ci->Install_model->language_file_read('dynamic_blocks', 'moderators', $langs_ids);

        // install moderators permissions
        $this->ci->load->model('Moderators_model');
        $params['where']['module'] = 'dynamic_blocks';
        $methods = $this->ci->Moderators_model->get_methods_lang_export($params);

        foreach ($methods as $method) {
            if (!empty($langs_file[$method['method']])) {
                $this->ci->Moderators_model->save_method($method['id'], array(), $langs_file[$method['method']]);
            }
        }
    }

    /**
     * Export languages of moderators module
     *
     * @param array $langs_ids languages identifiers
     *
     * @return array
     */
    public function install_moderators_lang_export($langs_ids)
    {
        $this->ci->load->model('Moderators_model');
        $params['where']['module'] = 'dynamic_blocks';
        $methods = $this->ci->Moderators_model->get_methods_lang_export($params, $langs_ids);
        foreach ($methods as $method) {
            $return[$method['method']] = $method['langs'];
        }

        return array('moderators' => $return);
    }

    /**
     * Uninstall data of moderators module
     *
     * @return void
     */
    public function deinstall_moderators()
    {
        // delete moderation methods in moderators
        $this->ci->load->model('Moderators_model');
        $params['where']['module'] = 'dynamic_blocks';
        $this->ci->Moderators_model->delete_methods($params);
    }

    /**
     * Install data of uploads module
     *
     * @return void
     */
    public function install_uploads()
    {
        // upload config
        $this->ci->load->model("uploads/models/Uploads_config_model");

        $watermark_ids = array();

        foreach ((array) $this->uploads as $upload_data) {
            $config_data = array(
                "gid" => $upload_data["gid"],
                "name" => $upload_data["name"],
                "min_height" => isset($upload_data["min_height"]) ? $upload_data["min_height"] : 0,
                "min_width" => isset($upload_data["min_width"]) ? $upload_data["min_width"] : 0,
                "max_height" => $upload_data["max_height"],
                "max_width" => $upload_data["max_width"],
                "max_size" => $upload_data["max_size"],
                "name_format" => $upload_data["name_format"],
                "file_formats" => serialize((array) $upload_data["file_formats"]),
                "default_img" => $upload_data["default_img"],
                "date_add" => date("Y-m-d H:i:s"),
            );
            $config_id = $this->ci->Uploads_config_model->save_config(null, $config_data);

            $wm_data = $this->ci->Uploads_config_model->get_watermark_by_gid("image-wm");
            //$wm_id = isset($wm_data["id"]) ? $wm_data["id"] : 0;

            foreach ((array) $upload_data["thumbs"] as $thumb_gid => $thumb_data) {
                if (isset($thumb_data["watermark"])) {
                    if (!isset($watermark_ids[$thumb_data["watermark"]])) {
                        $wm_data = $this->ci->Uploads_config_model->get_watermark_by_gid($thumb_data["watermark"]);
                        $watermark_ids[$thumb_data["watermark"]] = isset($wm_data["id"]) ? $wm_data["id"] : 0;
                    }
                    $watermark_id = $watermark_ids[$thumb_data["watermark"]];
                } else {
                    $watermark_id = 0;
                }

                $thumb_data["config_id"] = $config_id;
                $thumb_data["prefix"] = $thumb_gid;
                $thumb_data["effect"] = "none";
                $thumb_data["watermark_id"] = $watermark_id;

                $validate_data = $this->ci->Uploads_config_model->validate_thumb(null, $thumb_data);
                if (!empty($validate_data["errors"])) {
                    continue;
                }
                $this->ci->Uploads_config_model->save_thumb(null, $validate_data["data"]);
            }
        }
    }

    /**
     * Uninstall data of uploads module
     *
     * @return void
     */
    public function deinstall_uploads()
    {
        $this->ci->load->model("uploads/models/Uploads_config_model");

        foreach ((array) $this->uploads as $upload_data) {
            $config_data = $this->ci->Uploads_config_model->get_config_by_gid($upload_data["gid"]);
            if (empty($config_data["id"])) {
                continue;
            }
            $this->ci->Uploads_config_model->delete_config($config_data["id"]);
        }
    }

    /**
     * Install module data
     *
     * @return void
     */
    public function _arbitrary_installing()
    {
        // add entries for lang data updates
        foreach ($this->lang_dm_data as $lang_dm_data) {
            $this->ci->pg_language->add_dedicate_modules_entry($lang_dm_data);
        }

        $this->ci->load->model("Dynamic_blocks_model");

        $area_ids = array();

        $langs_ids = array();
        $langs_codes = array();

        foreach ($this->pg_language->languages as $lid => $lang_data) {
            $langs_ids[] = $lid;
            $langs_codes[$lid] = $lang_data['code'];
        }

        $this->ci->load->model("Dynamic_blocks_model");

        include MODULEPATH . "dynamic_blocks/install/demo_content.php";

        $blocks_area_data = array();

        foreach ((array) $demo_areas as $block_gid => $block_data) {
            foreach ($block_data as $area_gid => $area_data) {
                foreach ($langs_ids as $lid) {
                    if (isset($area_data[$langs_codes[$lid]])) {
                        foreach ($area_data[$langs_codes[$lid]] as $param_name => $param_value) {
                            $blocks_area_data[$block_gid][$area_gid]['params'][$param_name . '_' . $lid] = $param_value;
                        }
                    } else {
                        foreach ($area_data['en'] as $param_name => $param_value) {
                            $blocks_area_data[$block_gid][$area_gid]['params'][$param_name . '_' . $lid] = $param_value;
                        }
                    }
                }
            }
        }

        include MODULEPATH . "dynamic_blocks/install/demo_content.php";

        $blocks_presets_area_data = array();

        foreach ((array) $demo_presets_areas as $block_gid => $block_data) {
            foreach ($block_data as $preset_gid => $preset_data) {
                foreach ($preset_data as $area_gid => $area_data) {
                    foreach ($langs_ids as $lid) {
                        if (isset($area_data[$langs_codes[$lid]])) {
                            foreach ($area_data[$langs_codes[$lid]] as $param_name => $param_value) {
                                $blocks_presets_area_data[$block_gid][$preset_gid][$area_gid]['params'][$param_name . '_' . $lid] = $param_value;
                            }
                        } else {
                            foreach ($area_data['en'] as $param_name => $param_value) {
                                $blocks_presets_area_data[$block_gid][$preset_gid][$area_gid]['params'][$param_name . '_' . $lid] = $param_value;
                            }
                        }
                    }
                }
            }
        }

        foreach ((array) $this->dynamic_blocks as $block_data) {
            $validate_data = $this->ci->Dynamic_blocks_model->validate_block(null, $block_data);
            if (!empty($validate_data["errors"])) {
                continue;
            }
            $id_block = $this->ci->Dynamic_blocks_model->save_block(null, $validate_data["data"]);

            if (!empty($block_data["area"])) {
                if (!isset($area_ids[$block_data["area"]["gid"]])) {
                    $area = $this->ci->Dynamic_blocks_model->get_area_by_gid($block_data["area"]["gid"]);
                    $area_ids[$block_data["area"]["gid"]] = $area["id"];
                }

                // index area
                $block_data["area"]["id_area"] = $area_ids[$block_data["area"]["gid"]];
                $block_data["area"]["id_block"] = $id_block;

                if (isset($blocks_area_data[$block_data['gid']][$block_data["area"]["gid"]])) {
                    $block_data["area"]["params"] = array_merge($block_data["area"]["params"], $blocks_area_data[$block_data['gid']][$block_data["area"]["gid"]]["params"]);
                }

                $validate_data = $this->ci->Dynamic_blocks_model->validate_area_block(null, $block_data["area"]);
                if (empty($validate_data["errors"])) {
                    $this->ci->Dynamic_blocks_model->save_area_block(null, $validate_data["data"]);
                }
            }

            if (!empty($block_data["presets"])) {
                foreach ($block_data["presets"] as $preset_data) {
                    $preset = $this->ci->Dynamic_blocks_model->get_preset_by_gid($preset_data['gid_preset']);
                    $preset_data['id_preset'] = $preset['id'];
                    $preset_data['id_block'] = $id_block;

                    if (isset($blocks_presets_area_data[$block_data['gid']][$preset_data['gid_preset']][$preset_data['gid_area']])) {
                        $preset_data["params"] = array_merge($preset_data["params"], $blocks_presets_area_data[$block_data['gid']][$preset_data['gid_preset']][$preset_data['gid_area']]["params"]);
                    }

                    $validate_data = $this->ci->Dynamic_blocks_model->validate_preset_block(null, $preset_data);
                    if (!empty($validate_data["errors"])) {
                        continue;
                    }
                    $this->ci->Dynamic_blocks_model->save_preset_block(null, $validate_data["data"]);
                }
            }
        }
    }

    /**
     * Import module languages
     *
     * @param array $langs_ids languages identifiers
     *
     * @return void
     */
    public function _arbitrary_lang_install($langs_ids = null)
    {
        if (!is_array($langs_ids)) {
            $langs_ids = (array) $langs_ids;
        }
        if (empty($langs_ids)) {
            return false;
        }

        $langs_file = $this->ci->Install_model->language_file_read("dynamic_blocks", "arbitrary", $langs_ids);
        if (!$langs_file) {
            log_message("error", "Empty dynamic_blocks langs data");
            return false;
        }

        $this->ci->load->model("Dynamic_blocks_model");

        $data = array();

        foreach ((array) $this->dynamic_blocks as $block_data) {
            $block = $this->ci->Dynamic_blocks_model->get_block_by_gid($block_data["gid"]);
            if (!$block) {
                continue;
            }
            $data[] = $block;
        }

        $this->ci->Dynamic_blocks_model->update_langs($data, $langs_file, $langs_ids);
    }

    /**
     * Export module languages
     *
     * @param array $langs_ids languages identifiers
     *
     * @return array
     */
    public function _arbitrary_lang_export($langs_ids = null)
    {
        if (!is_array($langs_ids)) {
            $langs_ids = (array) $langs_ids;
        }

        $this->ci->load->model("Dynamic_blocks_model");

        $data = array();

        foreach ((array) $this->dynamic_blocks as $block_data) {
            $block = $this->ci->Dynamic_blocks_model->get_block_by_gid($block_data["gid"]);
            if (!$block) {
                continue;
            }
            $data[] = $block;
        }

        $langs = $this->ci->Dynamic_blocks_model->export_langs($data, $langs_ids);

        return array("arbitrary" => $langs);
    }

    /**
     * Uninstall module data
     *
     * @return array
     */
    public function _arbitrary_deinstalling()
    {
        $this->ci->load->model("Dynamic_blocks_model");
        foreach ((array) $this->dynamic_blocks as $block_data) {
            $this->ci->Dynamic_blocks_model->delete_block_by_gid($block_data["gid"]);
        }

        // delete entries in dedicate modules
        foreach ($this->lang_dm_data as $lang_dm_data) {
            $this->ci->pg_language->delete_dedicate_modules_entry(array('where' => $lang_dm_data));
        }
    }

}
