<?php

namespace Pg\Modules\Get_token\Controllers;

/**
 * Get token module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Get token user side controller
 *
 * @package 	PG_RealEstate
 * @subpackage 	Get token
 *
 * @category	controllers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Api_get_token extends \Controller
{

    /**
     * Constructor
     *
     * @return Api_get_token
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Get token for request to api
     * 
     * @return void
     */
    public function index()
    {
        $errors = array();
        $return = array();
        $token = '';

        $is_users_installed = $this->pg_module->is_module_active("users");
        if ($is_users_installed) {
            $this->load->model("users/models/Auth_model");
            $this->load->model("Users_model");
            $data = array(
                "email" => trim(strip_tags($this->input->get_post('email', true))),
                "password" => trim(strip_tags($this->input->get_post('password', true))),
            );

            if (empty($data['email']) && empty($data['password'])) {
                $token = $this->session->sess_create_token();
                $this->set_api_content('data', array('token' => $token));
            } else {
                $validate = $this->Auth_model->validate_login_data($data);
                if (!empty($validate["errors"])) {
                    $errors = array(array_shift($validate["errors"]));
                    $this->set_api_content('errors', $errors);
                    $token = $this->session->sess_destroy();
                } else {
                    $login_return = $this->Auth_model->login_by_email_password(
                            $validate["data"]["email"],
                            $this->Users_model->encode_password($validate["data"]["password"])
                    );
                    if (!empty($login_return["errors"])) {
                        $errors = $login_return["errors"];
                        $this->set_api_content('errors', $errors);
                        $token = $this->session->sess_destroy();
                    } else {
                        $token = $this->session->sess_create_token();
                        $this->set_api_content('data', array('token' => $token));
                    }
                }
            }
        } else {
            $token = $this->session->sess_create_token();
            $this->set_api_content('data', array('token' => $token));
        }
    }

}
