<?php

namespace Pg\Modules\Languages\Controllers;

/**
 * Languages module
 *
 * @package     PG_RealEstate
 *
 * @copyright   Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author      Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Languages user side controller
 *
 * @package     PG_RealEstate
 * @subpackage  Languages
 *
 * @category    controllers
 *
 * @copyright   Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author      Pilot Group Ltd <http://www.pilotgroup.net/>
 */
class Languages extends \Controller
{

    /**
     * Constructor
     *
     * @return Language
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Change current language
     *
     * @param integer $lang_id language identifier
     *
     * @return void
     */
    public function change_lang($lang_id)
    {
        $lang_id = intval($lang_id);
        $this->session->set_userdata("lang_id", $lang_id);

        $old_code = $this->pg_language->languages[$this->pg_language->current_lang_id]["code"];
        $this->pg_language->current_lang_id = $lang_id;
        $code = $this->pg_language->languages[$lang_id]["code"];
        $_SERVER["HTTP_REFERER"] = str_replace("/" . $old_code . "/", "/" . $code . "/", $_SERVER["HTTP_REFERER"]);
        $site_url = str_replace("/" . $code . "/", "", site_url());

        if (strpos($_SERVER["HTTP_REFERER"], $site_url) !== false) {
            redirect($_SERVER["HTTP_REFERER"]);
        } else {
            redirect();
        }
    }

    /**
     * Save module page text by ajax
     *
     * @param string  $module_gid module guid
     * @param string  $gid        text guid
     * @param integer $lang_id    language identifier
     *
     * @return void
     */
    public function ajax_pages_save($module_gid, $gid, $lang_id = '')
    {
        if ($_ENV['ADD_LANG_MODE']) {
            //          $value = html_entity_decode($this->input->post("text", true));
            $value = $this->input->post("text", true);

            if (!empty($gid)) {
                $this->pg_language->pages->set_string($module_gid, $gid, $value, $lang_id);
            }
            $this->view->output($value);
        }

        $this->view->render();
    }

}
