function bookingForm(optionArr) {
    this.properties = {
        siteUrl: '',
        backBtnLang: '',
        contentCustomClass: '',
        bookingBtn: 'book_listing',
        deleteBtn: '',
        isGetPeriods: false,
        showBookedMessage: false,
        cFormId: 'order_form',
        urlGetForm: 'listings_booking/ajax_order_form/',
        urlSaveForm: 'listings_booking/ajax_save_order/',
        urlGetPage: 'listings_booking/order_form/',
        urlGetPrice: 'listings_booking/ajax_get_booking_price/',
        urlGetPeriods:'listings_booking/ajax_get_periods',
        urlDeletePeriod: '',
        urlRewritePeriods: 'listings_booking/ajax_rewrite_periods',
        rewriteFormId: 'rewrite_period_form',
        rewriteBtnSaveId: 'rewrite_btn',
        rewriteBtnCloseId: 'rewrite_close_btn',
        note_delete: '',
        saveFormBtnId: 'save_form',
        listingId: 0,
        periodId: 0,
        priceType: '',
        isPopup: true,
        isSavePeriod: true,
        showPrice: false,
        displayLogin: false,
        successCallback: null,
        deleteCallback: null,
        contentObj: null,
        errorObj: new Errors,
        newPageOnSuccess: false
    };

    var _self = this;

    this.Init = function (options) {        
        _self.properties = $.extend(_self.properties, options);
        if (!_self.properties.contentObj) {
            _self.properties.contentObj = new loadingContent();
        }
        if (_self.properties.contentCustomClass) {
            _self.properties.contentObj.setCustomClass(_self.properties.contentCustomClass);
        }

        if (_self.properties.isPopup) {
            $('#' + _self.properties.bookingBtn).bind('click', function () {
                _self.get_form();
                return false;
            }).show();
        } else {
            $('#' + _self.properties.cFormId).bind('submit', function () {
                if (_self.properties.displayLogin) {
                    $('html, body').animate({
                        scrollTop: $("#ajax_login_link").offset().top
                    }, 2000);
                    $("#ajax_login_link").click();
                } else {
                    _self.save_form($(this).serialize());
                }
                return false;
            });
            _self.init_price();
        }

        if (_self.properties.deleteBtn) {
            $('#' + _self.properties.deleteBtn).bind('click', function () {
                if (confirm(_self.properties.note_delete)) {
                    _self.delete_period();
                }
                return false;
            });
        }
    };

    this.get_periods = function () {
        var url = _self.properties.siteUrl + _self.properties.urlGetPeriods;
        var params = {'where' : {'id_listing' :  _self.properties.listingId, 'status' : 'approve'}};
        var order_by = {'date_start' : 'ASC'};
         $.ajax({
            url: url,
            type: 'POST',
            dataType: 'json',
            data: {params : params, order_by : order_by},
            success: function (data) {
                if (data.periods) {
                    var res = data.periods[_self.properties.listingId];
                    var periods = {};
                    var is_edit = false;
                    var curr_date = Date.now();
                    var is_get_period = false;
                    if(_self.properties.periodId) {
                        is_edit = true;
                    }
                    if(res){
                        for(i in res) {
                            is_get_period = false;
                            if(is_edit) {
                                if(res[i]['id'] != _self.properties.periodId) {
                                    if (curr_date < Date.parse(res[i]['date_end'])) {
                                        is_get_period = true;                            
                                    }  
                                }
                            } else {
                                if (curr_date < Date.parse(res[i]['date_end'])) {
                                    is_get_period = true;   
                                }  
                            }
                            if (is_get_period) {
                                periods[i] = {'date_start' : Date.parse(res[i]['date_start'] + ' 00:00:00'), 'date_end' : Date.parse(res[i]['date_end'] + ' 00:00:00')};   
                            }
                        }
                    }
                    localStorage.setItem('listing_periods', JSON.stringify(periods));
                } else {
                    localStorage.setItem('listing_periods', null);
                }
                _self.get_content();
            }
        });
    }

    this.get_content = function () {
        if(_self.properties.newPageOnSuccess) {
            location.href = _self.properties.siteUrl + _self.properties.urlGetPage + _self.properties.listingId;
            return false;
        }
        var url = _self.properties.siteUrl + _self.properties.urlGetForm + _self.properties.listingId;
        if (_self.properties.periodId) {
            url += '/' + _self.properties.periodId;
        } else {
            _self.properties.periodId = '';
        }

        localStorage.setItem('periodId', _self.properties.periodId);
   
        $.ajax({
            url: url,
            type: 'POST',
            cache: false,
            data: {form_id : _self.properties.cFormId},
            success: function (data) {
                if ( _self.properties.contentObj.properties.removeOnClose == true) {
                    _self.properties.contentObj = new loadingContent();
                    if (_self.properties.contentCustomClass) {
                        _self.properties.contentObj.setCustomClass(_self.properties.contentCustomClass);
                    }
                }
                _self.properties.contentObj.removeOnClose();
                _self.properties.contentObj.show_load_block(data);
                $('#' + _self.properties.saveFormBtnId).unbind().bind('click', function () {
                    _self.clearBox();
                    return false;
                });

                if (_self.properties.showPrice) {
                    _self.init_price();
                }
            }
        });
        return false;
    }

    this.get_form = function () {
        if (_self.properties.isGetPeriods) {
            _self.get_periods();
        } else {
            _self.get_content();
        }
    };

    this.save_form = function (data) {
        var url = _self.properties.siteUrl + _self.properties.urlSaveForm + _self.properties.listingId;
        if (_self.properties.periodId)
            url += '/' + _self.properties.periodId;
        $.ajax({
            url: url,
            type: 'post',
            data: data,
            dataType: 'json',
            success: function (data) {
                if (typeof (data.error) !== 'undefined' && data.error != '') {
                    _self.properties.errorObj.show_error_block(data.error, 'error');
                } else if (data.intersect_periods) { 
                    var start = Date.parse(data.data.date_start);
                    var end = Date.parse(data.data.date_end);
                    var delete_periods = {};
                    var rewrite_periods = {};
                    var new_periods = { 0 : {} , 1 : {} };
                    data.data.date_start = new Date(data.data.date_start).toUTCString();
                    data.data.date_end = new Date(data.data.date_end).toUTCString();
                    if(_self.properties.periodId) {
                         data.data.id = _self.properties.periodId;
                    }
                    for(i in data.intersect_periods) {
                        var period = {};
                        var intersect_start = Date.parse(data.intersect_periods[i].date_start);
                        var intersect_end = Date.parse(data.intersect_periods[i].date_end);
                        if (intersect_start >= start && intersect_end <= end) {
                            delete_periods[i] = data.intersect_periods[i].id;
                        } else if (intersect_start < start && intersect_end > end) {
                            delete_periods[i] = data.intersect_periods[i].id;
                            new_periods[0].date_start = new Date(intersect_start).toUTCString();
                            new_periods[0].date_end = new Date(start - 86400000).toUTCString(); 
                            new_periods[0].price = data.intersect_periods[i].price;
                            new_periods[0].status = 'open';
                            new_periods[1].date_start = new Date(end + 86400000).toUTCString();
                            new_periods[1].date_end = new Date(intersect_end).toUTCString();
                            new_periods[1].price = data.intersect_periods[i].price;
                            new_periods[1].status = 'open';
                        } else {
                            period.date_start =  new Date(intersect_start).toUTCString();
                            period.date_end = new Date(intersect_end).toUTCString();
                            period.price = data.intersect_periods[i].price;
                            period.status = 'open';
                            period.id = data.intersect_periods[i].id;
                            if(intersect_start >= start && intersect_start <= end ) {
                                period.date_start =  new Date(end + 86400000).toUTCString();
                            } else if(intersect_end >= start && intersect_end <= end ) {
                                period.date_end =  new Date(start - 86400000).toUTCString();  
                            }
                            rewrite_periods[i] = period;
                            delete period;
                        }
                    }  
                    $('#'+_self.properties.rewriteFormId).show();
                    $('#'+_self.properties.cFormId).hide();

                    if (_self.properties.rewriteBtnCloseId) {
                        $('#' + _self.properties.rewriteBtnCloseId).click( function () {
                            $('#'+_self.properties.rewriteFormId).hide();
                            $('#'+_self.properties.cFormId).show();
                        });
                    }
                    if (_self.properties.rewriteBtnSaveId) {
                        $('#' + _self.properties.rewriteFormId).submit( function (e) {
                            e.preventDefault();
                            $('#' + _self.properties.rewriteBtnSaveId).addClass('disabled');
                            $('#' + _self.properties.rewriteBtnCloseId).addClass('disabled');
                            
                            _self.rewritePricePeriods(rewrite_periods, delete_periods, new_periods, data.data);
                        });
                    }
                } else {
                    if (_self.properties.isPopup) {
                        _self.properties.contentObj.hide_load_block();
                    }else if(_self.properties.newPageOnSuccess){
                        $('#booking_form_container').html('<p>' + data.success + 
                        '</p>'+
                        '<a href="' + _self.properties.siteUrl + '"'+
                        ' class="btn btn-default">' + _self.properties.backBtnLang + '</a>');
                    } else {
                        $('#' + _self.properties.cFormId).find('textarea').val('');
                    }
                    if (_self.properties.isSavePeriod) {
                        _self.properties.periodId = data.id;
                    }
                    if (_self.properties.successCallback) {
                        _self.properties.successCallback(data.id, data.data);
                    }
                }
                if (_self.properties.showBookedMessage && data['message_for_user']) {
                    var message = new loadingContent();
                    message.removeOnClose();
                    message.show_load_block(data['message_for_user']);
                } else if (data.success.length > 0) {
                    _self.properties.errorObj.show_error_block(data.success, 'success');
                }

            }
        });
        return false;
    };

    this.rewritePricePeriods = function(rewrite_periods, delete_periods, new_periods, new_data) {
        var url = _self.properties.siteUrl + _self.properties.urlRewritePeriods;
        var data = {'rewrite_periods' : rewrite_periods, 'delete_periods' : delete_periods, 'new_periods' : new_periods,  'new_data' : new_data};
        $.ajax({
            url: url,
            type: 'POST',
            dataType: 'json',
            data: {data : data},
            success: function (data) {
                if (typeof (data.error) !== 'undefined' && data.error != '') {
                    _self.properties.errorObj.show_error_block(data.error, 'error');
                    $('#'+_self.properties.rewriteFormId).hide();
                    $('#'+_self.properties.cFormId).show();
                    $('#'+_self.properties.rewriteBtnSaveId).removeClass('disabled');
                    $('#'+_self.properties.rewriteBtnCloseId).removeClass('disabled');
                } else {
                    if (_self.properties.isPopup) {
                        _self.properties.contentObj.hide_load_block();
                    }else if(_self.properties.newPageOnSuccess){
                        $('#booking_form_container').html('<p>' + data.success + 
                        '</p>'+
                        '<a href="' + _self.properties.siteUrl + '"'+
                        ' class="btn btn-default">' + _self.properties.backBtnLang + '</a>');
                    } else {
                        $('#' + _self.properties.cFormId).find('textarea').val('');
                    } 
                    if (_self.properties.successCallback) {
                        if (_self.properties.isSavePeriod) {
                            _self.properties.periodId = data.data.new_data.id;
                        }

                        if (data.data.delete_periods) {
                            $.each(data.data.delete_periods, function(index, value) {
                                $("#period" + value).remove();
                            }); 
                        }
                        if (data.data.rewrite_periods) {
                            $.each(data.data.rewrite_periods, function(index, value) {
                                _self.properties.successCallback(value.id, value.data);
                            });
                        }
                        if (data.data.new_periods) {
                            $.each(data.data.new_periods, function(index, value) {
                                _self.properties.successCallback(value.id, value.data);
                            });
                        }
                        if (data.data.new_data) {
                            _self.properties.successCallback(data.data.new_data.id, data.data.new_data.data);
                        }
                    }
                }
            }
        });
    }

    this.get_price = function () {
        var date_start, date_start_alt;
        var date_end, date_end_alt;

        switch (_self.properties.priceType) {
            case '1':
                date_start = $('#' + _self.properties.cFormId + ' input[name=period\\[date_start\\]]').val();
                date_end = $('#' + _self.properties.cFormId + ' input[name=period\\[date_end\\]]').val();

                date_start_alt = '';
                date_end_alt = '';
                break;
            case '2':
                date_start = $('#' + _self.properties.cFormId + ' select[name=date_start_year]').val() + '-' + $('#' + _self.properties.cFormId + ' select[name=date_start_month]').val() + '-01';
                date_end = $('#' + _self.properties.cFormId + ' select[name=date_end_year]').val() + '-' + $('#' + _self.properties.cFormId + ' select[name=date_end_month]').val() + '-01';

                date_start_alt = '';
                date_end_alt = '';
                break;
        }

        var guests = $('#' + _self.properties.cFormId + ' select[name=period\\[guests\\]]').val();

        var url = _self.properties.siteUrl + _self.properties.urlGetPrice + +_self.properties.listingId;
        $.ajax({
            url: url,
            type: 'post',
            data: {date_start: date_start, date_start_alt: date_start_alt, date_end: date_end, date_end_alt: date_end_alt, guests: guests},
            dataType: 'json',
            cache: false,
            success: function (data) {
                $('#' + _self.properties.cFormId).find('.booking_price_value').html(data.price);
            }
        });
    };

    this.clearBox = function () {
        var data = $('#' + _self.properties.cFormId).serialize();
        _self.save_form(data);
    };

    this.delete_period = function () {
        var url = _self.properties.siteUrl + _self.properties.urlDeletePeriod + _self.properties.periodId;
        $.ajax({
            url: url,
            type: 'get',
            cache: false,
            dataType: 'json',
            success: function (data) {
                if (typeof (data.error) !== 'undefined' && data.error != '') {
                    _self.properties.errorObj.show_error_block(data.error, 'error');
                } else {
                    _self.properties.errorObj.show_error_block(data.success, 'success');
                    $('#period' + _self.properties.periodId).remove();
                    if (_self.properties.deleteCallback) {
                        _self.properties.deleteCallback();
                    }
                }
            }
        });
    };

    this.set_calendar = function () {};

    this.init_price = function () {
        $('#' + _self.properties.cFormId + ' input[name=period\\[date_start\\]]').bind('change', function () {
            _self.get_price();
        });

        $('#' + _self.properties.cFormId + ' input[name=period\\[date_end\\]]').bind('change', function () {
            _self.get_price();
        });
        
        $('#' + _self.properties.cFormId + ' [name=daterange_start]').on('apply.daterangepicker', function () {
            _self.get_price();
        });
        
        $('#' + _self.properties.cFormId + ' [name=daterange_end]').on('apply.daterangepicker', function () {
            _self.get_price();
        });
        
        $('#' + _self.properties.cFormId + ' select[name=period\\[guests\\]]').bind('change', function () {
            _self.get_price();
        });

        $('#' + _self.properties.cFormId + ' select[name=date_start_month]').bind('change', function () {
            _self.get_price();
        });

        $('#' + _self.properties.cFormId + ' select[name=date_end_month]').bind('change', function () {
            _self.get_price();
        });

        $('#' + _self.properties.cFormId + ' select[name=date_start_year]').bind('change', function () {
            _self.get_price();
        });

        $('#' + _self.properties.cFormId + ' select[name=date_end_year]').bind('change', function () {
            _self.get_price();
        });
    };

    _self.Init(optionArr);
}
