<?php

/**
 * Moderation module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Moderation management
 *
 * @package 	PG_RealEstate
 * @subpackage 	Moderation
 *
 * @category	helpers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

if (!function_exists("admin_home_moderation_block")) {
    /**
     * Return homepage moderation statistics
     *
     * @return string
     */
    function admin_home_moderation_block()
    {
        $ci = &get_instance();

        $auth_type = $ci->session->userdata("auth_type");
        if ($auth_type != "admin") {
            return "";
        }

        $user_type = $ci->session->userdata("user_type");

        $show = true;

        $stat_moderation = array(
            "index_method" => true,
        );

        if ($user_type == "moderator") {
            $show = false;
            $ci->load->model("Moderators_model");
            $methods_moderation = $ci->Moderators_model->get_module_methods("moderation");
            if ((is_array($methods_moderation) && !in_array("index", $methods_moderation))) {
                $show = true;
            } else {
                $permission_data = $ci->session->userdata("permission_data");
                if ((isset($permission_data["moderation"]["index"]) && $permission_data["moderation"]["index"] == 1)) {
                    $show = true;
                    $stat_moderation["index_method"] = (bool) $permission_data["moderation"]["index"];
                }
            }
        }

        if (!$show) {
            return "";
        }

        $ci->load->model("Moderation_model");
        $ci->load->model("moderation/models/Moderation_type_model");

        $moderation_types = $ci->Moderation_type_model->get_types();
        foreach ($moderation_types as $i => $moderation_type) {
            if ($moderation_type['name'] != 'user_logo' && $moderation_type['name'] != 'upload_gallery') {
                unset($moderation_types[$i]);
                continue;
            }
            $stat_moderation['type_' . $moderation_type['name']] = $ci->Moderation_model->get_moderation_list_count($moderation_type['name']);
        }
        $stat_moderation['types'] = $moderation_types;

        $ci->view->assign("stat_moderation", $stat_moderation);

        return $ci->view->fetch("helper_admin_home_block", "admin", "moderation");
    }
}
