<?php

return [
    'menu' => [
        "guest_main_menu" => [
            "action" => "none",
            "name" => "User mode - Main menu for guests",
            "items" => [
                "main-menu-pro-item" => [
                    "action" => "create",
                    "link" => "users/index",
                    "status" => 1,
                    "sorter" => 3,
                    "items" => [
                        "main-menu-pro-agent-item" => [
                            "action" => "create",
                            "link" => "users/index/agent",
                            "status" => 1,
                            "sorter" => 1,
                        ],
                        "main-menu-pro-company-item" => [
                            "action" => "create",
                            "link" => "users/index/company",
                            "status" => 1,
                            "sorter" => 2,
                        ],
                    ],
                ],
            ],
        ],
        "company_main_menu" => [
            "action" => "create",
            "name" => "User mode - Main menu for agencies",
            "items" => [
                "company-main-menu-pro-item" => [
                    "action" => "create",
                    "link" => "users/index",
                    "status" => 1,
                    "sorter" => 3,
                    "items" => [
                        "company-main-menu-pro-agent-item" => [
                            "action" => "create",
                            "link" => "users/index/agent",
                            "status" => 1,
                            "sorter" => 1,
                        ],
                        "company-main-menu-pro-company-item" => [
                            "action" => "create",
                            "link" => "users/index/company",
                            "status" => 1,
                            "sorter" => 2,
                        ],
                    ],
                ],
            ],
        ],
        "agent_main_menu" => [
            "action" => "create",
            "name" => "User mode - Main menu for agents",
            "items" => [
                "agent-main-menu-pro-item" => [
                    "action" => "create",
                    "link" => "users/index",
                    "status" => 1,
                    "sorter" => 3,
                    "items" => [
                        "agent-main-menu-pro-agent-item" => [
                            "action" => "create",
                            "link" => "users/index/agent",
                            "status" => 1,
                            "sorter" => 1,
                        ],
                        "agent-main-menu-pro-company-item" => [
                            "action" => "create",
                            "link" => "users/index/company",
                            "status" => 1,
                            "sorter" => 2,
                        ],
                    ],
                ],
            ],
        ],
        "company_account_menu" => [
            "action" => "create",
            "name" => "User mode - Left menu for agencies",
            "items" => [
                "company_overview_item" => [
                    "action" => "create",
                    "link" => "start/homepage",
                    "status" => 1,
                    "sorter" => 1,
                ],
                "company_my_profile_item" => [
                    "action" => "create",
                    "link" => "users/profile",
                    "status" => 1,
                    "sorter" => 2,
                    "items" => [
                        "company_my_profile_edit_item" => [
                            "action" => "create",
                            "link" => "users/profile",
                            "status" => 1,
                            "sorter" => 1,
                        ],
                        "company_my_profile_change_regdata_item" => [
                            "action" => "create",
                            "link" => "users/change_reg_data",
                            "status" => 1,
                            "sorter" => 2,
                        ],
                    ],
                ],
                "company_my_agents_item" => [
                    "action" => "create",
                    "link" => "users/my_agents",
                    "status" => 1,
                    "sorter" => 8,
                    "items" => [
                        "company_my_agents_list_item" => [
                            "action" => "create",
                            "link" => "users/my_agents/list",
                            "status" => 1,
                            "sorter" => 1,
                        ],
                        "company_my_agents_requests_item" => [
                            "action" => "create",
                            "link" => "users/my_agents/requests",
                            "status" => 1,
                            "sorter" => 2,
                            'indicator_gid' => 'new_agent_item',
                        ],
                    ],
                    'indicator_gid' => 'all_agent_item',
                ],
            ],
        ],
        "agent_account_menu" => [
            "action" => "create",
            "name" => "User mode - Left menu for agents",
            "items" => [
                "agent_overview_item" => [
                    "action" => "create",
                    "link" => "start/homepage",
                    "status" => 1,
                    "sorter" => 1,
                ],
                "agent_my_profile_item" => [
                    "action" => "create",
                    "link" => "users/profile",
                    "status" => 1,
                    "sorter" => 2,
                    "items" => [
                        "agent_my_profile_edit_item" => [
                            "action" => "create",
                            "link" => "users/profile",
                            "status" => 1,
                            "sorter" => 1,
                            'indicator_gid' => 'agent_status_item',
                        ],
                        "agent_my_profile_change_regdata_item" => [
                            "action" => "create",
                            "link" => "users/change_reg_data",
                            "status" => 1,
                            "sorter" => 2,
                        ],
                    ],
                    'indicator_gid' => 'all_profile_item',
                ],
            ],
        ],
        "company_top_menu" => [
            "action" => "create",
            "name" => "User mode - Top menu for agencies",
            "items" => [
                "company-main-my-profile-item" => [
                    "action" => "create",
                    "link" => "users/profile",
                    "status" => 1,
                    "sorter" => 2,
                ],
                "company-main-my-agents-item" => [
                    "action" => "create",
                    "link" => "users/my_agents",
                    "status" => 1,
                    "sorter" => 8,
                ],
                "company-main-logout-item" => [
                    "action" => "create",
                    "link" => "users/logout",
                    "status" => 1,
                    "sorter" => 12,
                ],
            ],
        ],
        "agent_top_menu" => [
            "action" => "create",
            "name" => "User mode - Top menu for agents",
            "items" => [
                "agent-main-my-profile-item" => [
                    "action" => "create",
                    "link" => "users/profile",
                    "status" => 1,
                    "sorter" => 2,
                ],
                "agent-main-logout-item" => [
                    "action" => "create",
                    "link" => "users/logout",
                    "status" => 1,
                    "sorter" => 12,
                ],
            ],
        ],
        "guest_slide_menu" => [
            "action" => "create",
            "name" => "User mode - Slide menu for guests",
            "items" => [
                'guest-slide-search-item' => [
                    'action' => 'create',
                    "status" => 1,
                    "items" => [
                        "slide-menu-pro-item" => [
                            "action" => "create",
                            "link" => "users/index",
                            "status" => 1,
                            "sorter" => 5,
                        ],
                    ],
                ],
            ],
        ],
        "company_slide_menu" => [
            "action" => "create",
            "name" => "User mode - Slide menu for agencies",
            "items" => [
                'company-slide-search-item' => [
                    'action' => 'create',
                    "status" => 1,
                    "items" => [
                        "company-slide-menu-pro-item" => [
                            "action" => "create",
                            "link" => "users/index",
                            "status" => 1,
                            "sorter" => 5,
                        ],
                    ],
                ],
            ],
        ],
        "agent_slide_menu" => [
            "action" => "create",
            "name" => "User mode - Slide menu for agents",
            "items" => [
                'agent-slide-search-item' => [
                    'action' => 'create',
                    "status" => 1,
                    "items" => [
                        "agent-slide-menu-pro-item" => [
                            "action" => "create",
                            "link" => "users/index",
                            "status" => 1,
                            "sorter" => 5,
                        ],
                    ],
                ],
            ],
        ],
        "company_slide_profile_menu" => [
            "action" => "create",
            "name" => "User mode - Slide profile menu for agencies",
            "items" => [
                'company-slide-my-profile' => [
                    "action" => "create",
                    "status" => 1,
                    "items" => [
                        "company-slide-overview-item" => [
                            "action" => "create",
                            "link" => "start/homepage",
                            "status" => 1,
                            "sorter" => 1,
                        ],
                        "company-slide-my-profile-item" => [
                            "action" => "create",
                            "link" => "users/profile",
                            "status" => 1,
                            "sorter" => 2,
                        ],
                        "company-slide-my-agents-item" => [
                            "action" => "create",
                            "link" => "users/my_agents",
                            "status" => 1,
                            "sorter" => 8,
                        ],
                        "company-slide-logout-item" => [
                            "action" => "create",
                            "link" => "users/logout",
                            "status" => 1,
                            "sorter" => 12,
                        ],
                    ],
                ],
            ],
        ],
        "agent_slide_profile_menu" => [
            "action" => "create",
            "name" => "User mode - Slide profile menu for agents",
            "items" => [
                'agent-slide-my-profile' => [
                    "action" => "create",
                    "status" => 1,
                    "items" => [
                        "agent-slide-overview-item" => [
                            "action" => "create",
                            "link" => "start/homepage",
                            "status" => 1,
                            "sorter" => 1,
                        ],
                        "agent-slide-my-profile-item" => [
                            "action" => "create",
                            "link" => "users/profile",
                            "status" => 1,
                            "sorter" => 2,
                        ],
                        "agent-slide-logout-item" => [
                            "action" => "create",
                            "link" => "users/logout",
                            "status" => 1,
                            "sorter" => 12,
                        ],
                    ],
                ],
            ],
        ],
        "company_new_top_menu" => [
            "action" => "create",
            "name" => "User mode - Top menu for agencies",
            "items" => [
                "company-main-menu-pro-item" => [
                    "action" => "create",
                    "link" => "users/all-index",
                    "status" => 1,
                    "sorter" => 5,
                ],
            ],
        ],
        "agent_new_top_menu" => [
            "action" => "create",
            "name" => "User mode - Top menu for agents",
            "items" => [
                "agent-main-menu-pro-item" => [
                    "action" => "create",
                    "link" => "users/all-index",
                    "status" => 1,
                    "sorter" => 5,
                ],
            ],
        ],
        "guest_new_top_menu" => [
            "action" => "create",
            "name" => "User mode - Top menu for guests",
            "items" => [
                "guest-main-menu-pro-item" => [
                    "action" => "create",
                    "link" => "users/all-index",
                    "status" => 1,
                    "sorter" => 5,
                ],
            ],
        ],
        "admin_menu" => [
            "action" => "none",
            "name" => "",
            "items" => [
                "main_items" => [
                    "action" => "none",
                    "items" => [
                        "users_menu_item" => ["action" => "create", "link" => "admin/users", "icon" => "users", "status" => 1, "sorter" => 3],
                    ],
                ],
            ],
        ],
        "admin_users_menu" => [
            "action" => "create",
            "name" => "Admin mode - Users",
            "items" => [
                "users_list_item" => ["action" => "create", "link" => "admin/users", "status" => 1, "sorter" => 1],
                "groups_list_item" => ["action" => "create", "link" => "admin/users/groups", "status" => 1, "sorter" => 2],
            ],
        ],
        "admin_users_types_menu" => [
            "action" => "create",
            "name" => "Admin mode - Users - tabs",
            "items" => [
                "users_types_company_item" => ["action" => "create", "link" => "admin/users/index/company", "status" => 1, "sorter" => 2],
                "users_types_agent_item" => ["action" => "create", "link" => "admin/users/index/agent", "status" => 1, "sorter" => 3],
            ],
        ],
    ],
    'menu_payments' => [
        "company_payments_menu" => [
            "action" => "none",
            "name" => "",
            "items" => [
                'company_my_account_balance_item' => [
                    'action' => 'create',
                    'link' => 'users/account',
                    'status' => 1,
                    'sorter' => 1,
                    'indicator_gid' => 'new_account_item',
                ],
                'company_services_item' => [
                    'action' => 'create',
                    'link' => 'users/account_services',
                    'status' => 1,
                    'sorter' => 2,
                ],
            ],
        ],
        "agent_payments_menu" => [
            "action" => "none",
            "name" => "",
            "items" => [
                'agent_my_account_balance_item' => [
                    'action' => 'create',
                    'link' => 'users/account',
                    'status' => 1,
                    'sorter' => 1,
                    'indicator_gid' => 'new_account_item',
                ],
                'agent_services_item' => [
                    'action' => 'create',
                    'link' => 'users/account_services',
                    'status' => 1,
                    'sorter' => 2,
                ],
            ],
        ],
        "company_top_menu" => [
            "action" => "none",
            "name" => "",
            "items" => [
                "company-main-my-account-item" => [
                    "action" => "create",
                    "link" => "users/account",
                    "status" => 1,
                    "sorter" => 5,
                ],
            ],
        ],
        "agent_top_menu" => [
            "action" => "none",
            "name" => "",
            "items" => [
                "agent-main-my-account-item" => [
                    "action" => "create",
                    "link" => "users/account",
                    "status" => 1,
                    "sorter" => 5,
                ],
            ],
        ],
    ],
    'menu_users_services' => [
        "company_account_menu" => [
            "action" => "none",
            "name" => "",
            "items" => [
                "company_my_profile_item" => [
                    "action" => "none",
                    "items" => [
                        "company_my_profile_services_item" => [
                            "action" => "create",
                            "link" => "users/account_services",
                            "status" => 1,
                            "sorter" => 3,
                        ],
                    ],
                ],
            ],
        ],
        "agent_account_menu" => [
            "action" => "none",
            "name" => "",
            "items" => [
                "agent_my_profile_item" => [
                    "action" => "none",
                    "link" => "users/profile",
                    "status" => 1,
                    "sorter" => 2,
                    "items" => [
                        "agent_my_profile_services_item" => [
                            "action" => "create",
                            "link" => "users/account_services",
                            "status" => 1,
                            "sorter" => 3,
                        ],
                    ],
                    'indicator_gid' => 'all_profile_item',
                ],
            ],
        ],
    ],
    'menu_indicators' => [
        [
            'gid' => 'new_agent_item',
            'delete_by_cron' => false,
            'auth_type' => 'user',
        ],
        [
            'gid' => 'all_agent_item',
            'delete_by_cron' => false,
            'auth_type' => 'user',
        ],
        [
            'gid' => 'agent_status_item',
            'delete_by_cron' => false,
            'auth_type' => 'user',
        ],
        [
            'gid' => 'all_profile_item',
            'delete_by_cron' => false,
            'auth_type' => 'user',
        ],
    ],
    'menu_indicators_payments' => [
        [
            'gid' => 'new_account_item',
            'delete_by_cron' => true,
            'auth_type' => 'user',
        ],
        [
            'gid' => 'all_account_item',
            'delete_by_cron' => true,
            'auth_type' => 'user',
        ],
    ],
    'uploads' => [
        [
            "gid" => "user-logo",
            "name" => "User icon",
            "max_height" => 1000,
            "max_width" => 1000,
            "max_size" => 100000,
            "name_format" => "generate",
            "file_formats" => ["jpg", "gif", "png"],
            "default_img" => "default_user-logo.png",
            "indicator_img" => "indicator_user-logo.gif",
            "thumbs" => [
                "big" => ["width" => 200, "height" => 200, "effect" => "none", "crop_param" => "crop", "crop_color" => "ffffff"],
                "middle" => ["width" => 100, "height" => 100, "effect" => "none", "crop_param" => "crop", "crop_color" => "ffffff"],
                "small" => ["width" => 60, "height" => 60, "effect" => "none", "crop_param" => "crop", "crop_color" => "ffffff"],
            ],
        ],
    ],
    'moderators' => [
        ["module" => "users", "method" => "index", "is_default" => 1],
    ],
    'groups' => [
        ["gid" => "default", "is_default" => "1"],
        ["gid" => "simple-users", "is_default" => "0"],
        ["gid" => "vip-users", "is_default" => "0"],
    ],
    'seo' => [
        "module_gid" => "users",
        "model_name" => "Users_model",
        "get_settings_method" => "get_seo_settings",
        "get_rewrite_vars_method" => "request_seo_rewrite",
        "get_sitemap_urls_method" => "get_sitemap_xml_urls",
    ],
    'moderation_types' => [
        [
            "name" => "users",
            "mtype" => "-1",
            "module" => "users",
            "model" => "Users_model",
            "check_badwords" => "1",
            "method_get_list" => "",
            "method_set_status" => "",
            "method_delete_object" => "",
            "allow_to_decline" => "0",
            "template_list_row" => "",
        ],
        [
            "name" => "user_logo",
            "mtype" => "1",
            "module" => "users",
            "model" => "Users_model",
            "check_badwords" => "2",
            "method_get_list" => "_moder_get_list",
            "method_set_status" => "_moder_set_status",
            "method_delete_object" => "",
            "allow_to_decline" => "1",
            "template_list_row" => "moder_block",
        ],
    ],
    'notifications' => [
        "templates" => [
            ["gid" => "users_fogot_password", "name" => "Forgot password mail", "vars" => ["password", "email", "fname", "sname"], "content_type" => "text"],
            ["gid" => "users_account_create", "name" => "Account create letter", "vars" => ["password", "email", "fname", "sname", "nickname"], "content_type" => "text"],
            ["gid" => "users_change_password", "name" => "Change password notification", "vars" => ["password", "email", "fname", "sname", "nickname"], "content_type" => "text"],
            ["gid" => "users_change_email", "name" => "Email changed", "vars" => ["password", "email", "fname", "sname", "nickname"], "content_type" => "text"],
            ["gid" => "users_email_restore", "name" => "Email changed (notification to old email)", "vars" => ["password", "email", 'email_restore', "fname", "sname", "nickname", 'restore_link'], "content_type" => "text"],
            ["gid" => "users_registration", "name" => "User registration letter", "vars" => ["password", "email", "fname", "sname", "nickname", "confirm_block"], "content_type" => "text"],
            ["gid" => "agent_send_request", "name" => "Company notification informing that a member wants to become their agent", "vars" => ["fname", "sname", "user_name", "company_name"], "content_type" => "text"],
            ["gid" => "agent_cancel_request", "name" => "Company notification informing that a member canceled his request to become an agent of the company", "vars" => ["fname", "sname", "user_name", "company_name"], "content_type" => "text"],
            ["gid" => "agent_unjoin", "name" => "Company notification informing that a member removed himself from the list of their agents", "vars" => ["fname", "sname", "user_name", "company_name"], "content_type" => "text"],
            ["gid" => "agent_deleted", "name" => "Member notification informing that a company removed him from the list of their agents", "vars" => ["fname", "sname", "user_name", "company_name"], "content_type" => "text"],
            ["gid" => "agent_request_accepted", "name" => "Member notification informing that the company accepted his request to become an agent", "vars" => ["fname", "sname", "user_name", "company_name"], "content_type" => "text"],
            ["gid" => "agent_request_declined", "name" => "Member notification informing that the company declined his request to become their agent", "vars" => ["fname", "sname", "user_name", "company_name"], "content_type" => "text"],
            ["gid" => "user_account_create_by_admin", "name" => "User created by admin mail", "vars" => ["fname", "sname", "email", "password"], "content_type" => "text"],
            ["gid" => "users_change_phone", "name" => "User change phone", "vars" => ["fname", "sname", "email", "phone"], "content_type" => "text"],
            ["gid" => "phone_restore_code", "name" => "User restore phone", "vars" => ["fname", "sname", "email", "phone", "restore_link"], "content_type" => "text"],
        ],
        "notifications" => [
            ["gid" => "users_fogot_password", "template" => "users_fogot_password", "send_type" => "simple"],
            ["gid" => "users_account_create", "template" => "users_account_create", "send_type" => "simple"],
            ["gid" => "users_change_password", "template" => "users_change_password", "send_type" => "simple"],
            ["gid" => "users_change_email", "template" => "users_change_email", "send_type" => "simple"],
            ["gid" => "users_email_restore", "template" => "users_email_restore", "send_type" => "simple"],
            ["gid" => "users_registration", "template" => "users_registration", "send_type" => "simple"],
            ["gid" => "agent_send_request", "template" => "agent_send_request", "send_type" => "simple"],
            ["gid" => "agent_cancel_request", "template" => "agent_cancel_request", "send_type" => "simple"],
            ["gid" => "agent_unjoin", "template" => "agent_unjoin", "send_type" => "simple"],
            ["gid" => "agent_deleted", "template" => "agent_deleted", "send_type" => "simple"],
            ["gid" => "agent_request_accepted", "template" => "agent_request_accepted", "send_type" => "simple"],
            ["gid" => "agent_request_declined", "template" => "agent_request_declined", "send_type" => "simple"],
            ["gid" => "user_account_create_by_admin", "template" => "user_account_create_by_admin", "send_type" => "simple"],
            ["gid" => "users_change_phone", "template" => "users_change_phone", "send_type" => "simple"],
            ["gid" => "phone_restore_code", "template" => "phone_restore_code", "send_type" => "simple"],
        ],
    ],
    'reviews' => [
        "reviews_fields" => [
            "review_data" => ["type" => "TEXT", "null" => true],
            "review_count" => ["type" => "smallint(5)", "null" => false],
            "review_sorter" => ["type" => "decimal(5,3)", "null" => false],
            "review_value" => ["type" => "decimal(5,3)", "null" => false],
            "review_type" => ["type" => "varchar(20)", "null" => false],
        ],
        "reviews" => [
            ["gid" => "users_object", "name" => "Reviews in user profiles", "rate_type" => "stars", "module" => "users", "model" => "users", "callback" => "callback_reviews"],
        ],
        "rate_types" => [
            "stars" => [
                "main" => [1, 2, 3, 4, 5],
                "dop1" => [1, 2, 3, 4, 5],
                "dop2" => [1, 2, 3, 4, 5],
            ],
            "hands" => [
                "main" => [1, 5],
                "dop1" => [1, 5],
                "dop2" => [1, 5],
            ],
        ],
    ],
    'spam' => [
        ["gid" => "users_object", "form_type" => "select_text", "send_mail" => true, "status" => true, "module" => "users", "model" => "Users_model", "callback" => "spam_callback"],
    ],
    'geomap' => [
        [
            "map_gid" => "googlemapsv3",
            "id_user" => 0,
            "id_object" => 0,
            "gid" => "user_profile",
            "use_type_selector" => 1,
            "use_searchbox" => 0,
            "use_search_radius" => 1,
            "use_search_auto" => 1,
            "use_show_details" => 1,
            "use_clusterer" => 0,
            "use_amenities" => 1,
            "amenities" => ["bank"],
        ],
        [
            "map_gid" => "yandexmapsv2",
            "id_user" => 0,
            "id_object" => 0,
            "gid" => "user_profile",
            "use_type_selector" => 1,
            "use_searchbox" => 0,
            "use_tools" => 1,
            "use_clusterer" => 1,
            "use_click_zoom" => 1,
        ],
        [
            "map_gid" => "bingmapsv7",
            "id_user" => 0,
            "id_object" => 0,
            "gid" => "user_profile",
            "use_type_selector" => 1,
            "use_searchbox" => 0,
        ],
        [
            "map_gid" => "googlemapsv3",
            "id_user" => 0,
            "id_object" => 0,
            "gid" => "user_info",
            "use_clusterer" => 0,
            "zoom" => 10,
            "use_show_details" => 1,
        ],
        [
            "map_gid" => "yandexmapsv2",
            "id_user" => 0,
            "id_object" => 0,
            "gid" => "user_info",
            "zoom" => 10,
        ],
        [
            "map_gid" => "bingmapsv7",
            "id_user" => 0,
            "id_object" => 0,
            "gid" => "user_info",
            "zoom" => 10,
        ],
        [
            "map_gid" => "googlemapsv3",
            "id_user" => 0,
            "id_object" => 0,
            "gid" => "user_search",
            "zoom" => 5,
            "use_smart_zoom" => 1,
            "use_panorama" => 0,
            "use_router" => 0,
            "use_searchbox" => 0,
            "use_search_radius" => 0,
            "use_search_auto" => 0,
            "use_show_details" => 0,
            "use_clusterer" => 1,
            "use_amenities" => 0,
            "amenities" => ["bank"],
        ],
        [
            "map_gid" => "yandexmapsv2",
            "id_user" => 0,
            "id_object" => 0,
            "gid" => "user_search",
            "view_type" => 1,
            "zoom" => 5,
            "lat" => 0,
            "lon" => 0,
            "use_type_selector" => 1,
            "use_smart_zoom" => 1,
            "use_router" => 0,
            "use_searchbox" => 0,
            "use_tools" => 0,
            "use_clusterer" => 1,
            "use_click_zoom" => 1,
        ],
        [
            "map_gid" => "bingmapsv7",
            "id_user" => 0,
            "id_object" => 0,
            "gid" => "user_search",
            "view_type" => 1,
            "zoom" => 5,
            "lat" => 0,
            "lon" => 0,
            "use_type_selector" => 1,
            "use_smart_zoom" => 1,
            "use_router" => 0,
            "use_searchbox" => 0,
        ],
    ],
    'seo_settings' => [
        'account' => 'account',
        'index' => 'index',
        'login_form' => 'login_form',
        'profile' => 'profile',
        'register_agent' => 'reg_agent',
        'register_company' => 'reg_company',
        'restore' => 'restore',
        'search' => 'search',
        'view' => 'view',
    ],
    'social_networking' => [
        [
            'controller' => 'users',
            'method' => 'view',
            'name' => 'View user page',
            'data' => [
                'like' => ['facebook' => 'on', 'vkontakte' => 'on', 'google' => 'on'],
            ],
        ],
        [
            "controller" => "users",
            "method" => "reg_company",
            "name" => "Company registration page",
            "data" => [
                "like" => [
                    "facebook" => "on",
                    "vkontakte" => "on",
                    "google" => "on",
                ],
                "share" => [
                    "facebook" => "on",
                    "vkontakte" => "on",
                    "linkedin" => "on",
                    "twitter" => "on",
                ],
                "comments" => "1",
            ],
        ],
        [
            "controller" => "users",
            "method" => "reg_agent",
            "name" => "Agent registration page",
            "data" => [
                "like" => [
                    "facebook" => "on",
                    "vkontakte" => "on",
                    "google" => "on",
                ],
                "share" => [
                    "facebook" => "on",
                    "vkontakte" => "on",
                    "linkedin" => "on",
                    "twitter" => "on",
                ],
                "comments" => "1",
            ],
        ],
    ],
    'listings' => [
        "listings_fields" => [
            "listings_for_sale_count" => ["type" => "int(3)", "null" => false],
            "listings_for_buy_count" => ["type" => "int(3)", "null" => false],
            "listings_for_rent_count" => ["type" => "int(3)", "null" => false],
            "listings_for_lease_count" => ["type" => "int(3)", "null" => false],
        ],
    ],
    'export_data' => [
        "module" => "users",
        "model" => "Users_export_model",
        "callback_get_fields" => "callback_get_fields",
        "callback_get_admin_form" => "callback_get_admin_form",
        "callback_get_user_form" => "callback_get_user_form",
        "callback_process_form" => "callback_process_form",
        "callback_export_data" => "callback_export_data",
        "sorter" => "2",
    ],
    'import_data' => [
        "module" => "users",
        "model" => "Users_import_model",
        "callback_get_fields" => "callback_get_fields",
        "callback_import_data" => "callback_import_data",
        "sorter" => "2",
    ],
    'cronjobs' => [
        [
            "name" => "Update user visits",
            "module" => "users",
            "model" => "Users_visitor_model",
            "method" => "update_views_count_cron",
            "cron_tab" => "0 * * * *",
            "status" => "1",
        ],
    ],
    'field_editor_types' => ['user', 'company', 'agent'],
    'user_types' => [
        [
            'name' => 'agent',
            'parent_id' => 0,
        ],
        [
            'name' => 'company',
            'parent_id' => 0,
        ],
    ],
];
