function usersMenu(optionArr){
	this.properties = {
		siteUrl: '',
		viewAjaxUrl: 'users/ajax_get_section/',
		sectionId: 'user_sections',
		listBlockId: 'user_block',
		tryDisplayWithoutAjax: true,
		containerPrefix: 'content_',
		tabPrefix: 'm',
		tabClass: 'view-section',
		currentSection: 'contacts',
		errorObj: new Errors(),
		available_view: null,
		idUser: 0,
		idCompany: 0,
		template: '',
	}
	
	this.loaded = {};

	var _self = this;
	
	this.Init = function(options){ 
		_self.properties = $.extend(_self.properties, options);
		
		_self.loaded[_self.properties.tabPrefix + '_contacts'] = true;
		
		_self.init_links();
		
		if(_self.properties.available_view){
			_self.properties.available_view.set_properties({
				siteUrl: _self.properties.siteUrl,
				success_request: function(message){
					switch(_self.properties.currentSection){
						case _self.properties.tabPrefix+'_contacts':
							_self.loaded[_self.properties.tabPrefix+'_map'] = false;
							_self.loaded[_self.properties.tabPrefix+'_map_info'] = false;
						break;
						case _self.properties.tabPrefix+'_map':
						case _self.properties.tabPrefix+'_map_info':
							_self.loaded[_self.properties.tabPrefix+'_contacts'] = false;
						break;
					}
					
					_self.show_tab(_self.properties.currentSection, true);

					if(message){
						_self.properties.errorObj.show_error_block(message, 'success');
					}	
				},
				fail_request: function(message){
					_self.properties.errorObj.show_error_block(message, 'error');
				}
			});
		}
	}
	
	this.init_links = function(){
		var contacts_btn = '#'+_self.properties.containerPrefix+_self.properties.tabPrefix+'_contacts [name=contacts_btn], .listing-provided__agent';
		var map_btn = '#'+_self.properties.containerPrefix+_self.properties.tabPrefix+'_map input[name=map_btn],'+
					  '#'+_self.properties.containerPrefix+_self.properties.tabPrefix+'_map button[name=map_btn]';
		var map_info_btn = '#'+_self.properties.containerPrefix+_self.properties.tabPrefix+'_map_info input[name=map_info_btn],' +
						   '#'+_self.properties.containerPrefix+_self.properties.tabPrefix+'_map_info button[name=map_info_btn]';

		$(document).on('click', contacts_btn+','+map_btn+','+map_info_btn, function(){console.log(1)
			if(_self.properties.available_view){
				_self.properties.available_view.check_available(_self.properties.idUser);
			}else{
				_self.show_tab(_self.properties.currentSection, true);
			}
		});
	    
		$(document).on('click', '#'+_self.properties.sectionId+' li', function(){
			var id = $(this).attr('id');
			_self.properties.currentSection = id;
			switch(id){
				case _self.properties.tabPrefix+'_company':
					if(_self.properties.available_view){
						_self.properties.available_view.check_available(_self.properties.idCompany);
					}else{
						_self.show_tab(_self.properties.currentSection, true);
					}
				break;
				case _self.properties.tabPrefix+'_map':	
				case _self.properties.tabPrefix+'_map_info':	
				case _self.properties.tabPrefix+'_contacts':
					if(_self.loaded[id]){
						_self.show_tab(id, false);
					}else{
						_self.show_tab(id, true);
					}
				break;
				default:
					_self.show_tab(id, false);
				break;
			}
			return false;
		});
		
		_self.loaded[_self.properties.tabPrefix + '_' + _self.properties.currentSection] = true;
	}
	
	this.show_tab = function(id, load){
		$('#user_sections li').removeClass('active');
		$('#'+id).addClass('active');
			
		_self._hide_blocks();
		
		_self.show_block(id, load);
	}
	
	this.show_block = function(id, load){
		var section_gid = $('#'+id).attr('sgid');
		if(load){
			var url = _self.properties.siteUrl + _self.properties.viewAjaxUrl + 
					  _self.properties.idUser + '/' + section_gid +
					  (_self.properties.template ? '/' + _self.properties.template : '');
			$.ajax({
				url: url, 
				type: 'GET',
				cache: false,
				success: function(data){
					_self._show_block(section_gid).html(data);
					_self.loaded[id] = true;
				}
			});
		}else{
			_self._show_block(section_gid);
		}
	}
	
	this._show_block = function(section_gid){
		var prefix = _self.properties.containerPrefix+_self.properties.tabPrefix;
		return $('#' + prefix + '_' + section_gid).show();
	}
	
	this._hide_blocks = function(){
		$('#'+_self.properties.listBlockId).find('.' + _self.properties.tabClass).hide();
	}
	
	_self.Init(optionArr);
}
