<?php

use Pg\Libraries\View;

/**
 * Users_deactivate module
 *
 * @package 	PG_RealEstate
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

/**
 * Users_deactivate management
 *
 * @package 	PG_RealEstate
 * @subpackage 	Users_deactivate
 *
 * @category	helpers
 *
 * @copyright 	Copyright (c) 2000-2014 PG Real Estate - php real estate listing software
 * @author 		Pilot Group Ltd <http://www.pilotgroup.net/>
 */

if (!function_exists('get_user_deactivation_form')) {
    /**
     * Get deactivation form
     *
     * @param string $place page placement
     *
     * @return string
     */
    function get_user_deactivation_form()
    {
        $ci = &get_instance();

        $data = array();

        $user_id = $ci->session->userdata("user_id");
        $ci->load->model("Users_model");
        $ci->Users_model->set_format_settings('get_safe', false);
        $user = $ci->Users_model->get_user_by_id($user_id, true);
        $ci->Users_model->set_format_settings('get_safe', true);

        $deactivated_send_mail = $ci->pg_module->get_module_config("users_deactivate", "deactivated_send_mail");

        if ($ci->input->post("btn_save")) {
            $post_data["id_reason"] = $ci->input->post("reason_id");
            $post_data["message"] = $ci->input->post("message");
            $post_data['fname'] = $user["fname"];
            $post_data['sname'] = $user['sname'];
            $post_data["name"] = $user["output_name"];
            $post_data["email"] = $user["email"];
            $post_data["phone"] = $user["phone"];
            
            $ci->load->model('users_deactivate/models/Users_deactivated_alert_model');
            $validate_data = $ci->Users_deactivated_alert_model->validate_alert(null, $post_data);
            if (!empty($validate_data["errors"])) {
                $ci->system_messages->addMessage(View::MSG_ERROR, $validate_data["errors"]);
                $data = $validate_data["data"];
            } else {
                $ci->Users_model->delete_user($user_id);
                $deactivated_send_alert = $ci->pg_module->get_module_config("users_deactivate", "deactivated_send_alert");
                if ($deactivated_send_alert) {
                    $ci->Users_deactivated_alert_model->save_alert(null, $validate_data["data"]);
                }
                
                $mail_data = $validate_data["data"];
                $ci->load->model("Notifications_model");
                $ci->Notifications_model->send_notification($mail_data['email'], "users_deactivate", $validate_data["data"], '', $user['lang_id']);
                $deactivated_send_mail = $ci->pg_module->get_module_config("users_deactivate", "deactivated_send_mail");
                if ($deactivated_send_mail) {
                    $deactivated_email = $ci->pg_module->get_module_config("users_deactivate", "deactivated_email");
                    if ($deactivated_email) {
                        $mail_data = $validate_data["data"];
                        $ci->load->model("notifications/models/Notifications_model");
                        $ci->Notifications_model->send_notification($deactivated_email, "moderators_deactivated", $validate_data["data"]);
                    }
                }
                $ci->system_messages->addMessage(View::MSG_SUCCESS, l("success_user_deactivated", "users_deactivate"));
                $ci->load->model("users/models/Auth_model");
                $ci->Auth_model->logoff();
                redirect();
            }
        }
        
        return $ci->view->fetch('helper_form_user_deactivate', 'user', 'users_deactivate');
    }
}
